RectangleMorph subclass: #NmWorldMapEntryMorph
	instanceVariableNames: 'textMorph exists mapEntry oldDest locker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-WorldMap'!

!NmWorldMapEntryMorph methodsFor: 'dropping/grabbing' stamp: 'mu 5/13/2005 02:12'!
acceptDroppingMorph: morphToDrop event: evt 

	| formerOwner formerPosition |
	formerOwner _ morphToDrop formerOwner.
	formerPosition _ morphToDrop formerPosition.
	
	self frenchDoorOpen.

	morphToDrop afterWarpActions:  #(#zoomIn).
	morphToDrop
		warp: self ip
		port: self port
		x: morphToDrop topLeft x
		y: morphToDrop topLeft y
		onError: [:ex | 
			morphToDrop handleWarpError: ex.
			morphToDrop formerOwner: formerOwner.
			morphToDrop formerPosition: formerPosition.
			morphToDrop rejectDropMorphEvent: evt]! !

!NmWorldMapEntryMorph methodsFor: 'dropping/grabbing' stamp: 'mu 5/10/2005 02:54'!
justDroppedInto: aMorph event: anEvent
	super justDroppedInto: aMorph event: anEvent.
	locker notNil
		ifTrue: [self myLockerMap ifNotNilDo: [:lo | lo unlockWith: locker]]! !

!NmWorldMapEntryMorph methodsFor: 'dropping/grabbing' stamp: 'mu 5/10/2005 02:54'!
justGrabbedFrom: formerOwner
	super justGrabbedFrom: formerOwner.
	locker _ self myLockerMap ifNotNilDo: [:lo | lo lock].
	! !

!NmWorldMapEntryMorph methodsFor: 'dropping/grabbing' stamp: 'mu 5/10/2005 02:54'!
rejectDropMorphEvent: evt 
	super rejectDropMorphEvent: evt.
	locker notNil
		ifTrue: [self myLockerMap ifNotNilDo: [:lo | lo unlockWith: locker]]! !

!NmWorldMapEntryMorph methodsFor: 'dropping/grabbing' stamp: 'mu 6/21/2005 16:08'!
wantsDroppedMorph: aMorph event: evt
	aMorph isWarpable ifFalse: [^false].
	(aMorph isKindOf: NmWorldMapRowMorph) ifTrue: [^false].
	^(aMorph isKindOf: self class) not
	
	! !

!NmWorldMapEntryMorph methodsFor: 'dropping/grabbing' stamp: 'mu 4/15/2003 03:02'!
wantsToBeDroppedInto: aMorph 
	^(aMorph isKindOf: NmWorldMapRowMorph) or: [aMorph isKindOf: TrashCanMorph]
		! !


!NmWorldMapEntryMorph methodsFor: 'private' stamp: 'mu 4/10/2005 01:59'!
computeColor
	| col |
	self exists ifFalse: [^self class defaultVacantColor].
	col _ self isLocal
				ifTrue: [self class defaultLocalColor]
				ifFalse: [self class defaultExistsColor].
	self hasChanged
		ifTrue: [col _ self class defaultEditedColor].
	^ col! !

!NmWorldMapEntryMorph methodsFor: 'private' stamp: 'mu 7/6/2005 02:41'!
computeDestinationFrom: dest 
	oldDest = dest
		ifTrue: [^ self destinationLabelFrom: oldDest].
	oldDest _ dest.
	dest isNmUrlString
		ifTrue: [| url ip port | 
			url _ dest asNmUrl.
			ip _ url parsedIp.
			port _ url port.
			self mapEntry
				ifNotNilDo: [:ent | ip ifNotNil: [ent ip: ip].
						 ent port: port asNumber]].
	^ self destinationLabelFrom: dest! !

!NmWorldMapEntryMorph methodsFor: 'private' stamp: 'mu 1/21/2005 23:45'!
destinationLabelFrom: destString 
	| destStr label |
	destStr _ destString asString.
	label _ (destStr beginsWith: NmUrl protocolIdentifier)
				ifTrue: [| tailIndex | 
					tailIndex _ ((destStr endsWith: '/')
								ifTrue: [destStr size - 1]
								ifFalse: [destStr size])
								max: NmUrl protocolIdentifier size.
					destStr _ destStr copyFrom: NmUrl protocolIdentifier size + 1 to: tailIndex]
				ifFalse: [destStr].
	^ label copyReplaceAll: ':' with: String cr! !

!NmWorldMapEntryMorph methodsFor: 'private' stamp: 'mu 1/12/2005 01:49'!
isBadLocalUrlName: aString 
	^ aString isNmUrlString
		and: [(aString asNmUrl hostOrIpEquals: NmUrl local) not]! !

!NmWorldMapEntryMorph methodsFor: 'private' stamp: 'mu 5/10/2005 02:51'!
myLockerMap
	^self worldMapMorph ifNotNilDo: [:mo | mo worldMap]! !

!NmWorldMapEntryMorph methodsFor: 'private' stamp: 'mu 3/16/2005 01:13'!
resetBorderColor
	self borderColor: self computeColor! !

!NmWorldMapEntryMorph methodsFor: 'private' stamp: 'mu 3/16/2005 02:02'!
resetColor
	| col |
	col _ self computeColor.
	self borderColor: col.
	self exists
		ifFalse: [self color: col]! !


!NmWorldMapEntryMorph methodsFor: 'constants' stamp: 'mu 1/14/2005 01:39'!
defaultCellHeight
	^ self class defaultCellHeight! !

!NmWorldMapEntryMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 17:13'!
defaultCellWidth
	^ self class defaultCellWidth! !

!NmWorldMapEntryMorph methodsFor: 'constants' stamp: 'mu 3/16/2005 01:22'!
defaultColor
	^ self class defaultColor! !

!NmWorldMapEntryMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 17:13'!
defaultExistsColor
	^ self class defaultExistsColor! !

!NmWorldMapEntryMorph methodsFor: 'constants' stamp: 'mu 3/16/2005 02:06'!
defaultFillStyle
	| fill |
	fill _ GradientFillStyle ramp: {0.0 -> Color white. 1.0
					-> (Color
							r: 0.86
							g: 0.86
							b: 0.86)}.
	fill origin: self bounds topLeft + (14 @ 10).
	fill direction: 30 @ 6.
	fill radial: false.
	^ fill! !


!NmWorldMapEntryMorph methodsFor: 'describing state' stamp: 'mu 1/23/2005 05:07'!
descriptionString
	 self mapEntry ifNil: [^'<NO_ENTRY>'].
	^ self mapEntry descriptionString! !


!NmWorldMapEntryMorph methodsFor: 'actions' stamp: 'mu 1/9/2005 01:40'!
destination
	^ mapEntry isNil
		ifTrue: ['']
		ifFalse: [mapEntry destination]! !

!NmWorldMapEntryMorph methodsFor: 'actions' stamp: 'mu 3/8/2005 00:50'!
point
	mapEntry isNil ifTrue: [^0@0].
	^ mapEntry point! !

!NmWorldMapEntryMorph methodsFor: 'actions' stamp: 'mu 5/13/2005 20:32'!
setEntry: aNmMapEntry 
	| destStr oldMapEntry |
	aNmMapEntry isNil
		ifTrue: [^ self].
	destStr _ aNmMapEntry destination asString.
	self name: destStr.
	aNmMapEntry removeDependent: self.
	aNmMapEntry addDependent: self.
	oldMapEntry _ mapEntry.
	self mapEntry: aNmMapEntry.
	oldMapEntry isNil
		ifTrue: [self update: aNmMapEntry]! !


!NmWorldMapEntryMorph methodsFor: 'testing' stamp: 'mu 1/9/2005 01:34'!
exists
	^ mapEntry notNil! !

!NmWorldMapEntryMorph methodsFor: 'testing' stamp: 'mu 1/21/2005 23:26'!
hasChanged
	^ self mapEntry
		ifNil: [false]
		ifNotNil: [self mapEntry hasChanged]! !

!NmWorldMapEntryMorph methodsFor: 'testing' stamp: 'mu 1/9/2005 01:21'!
isLocal
	mapEntry isNil ifTrue: [^false].
	^mapEntry isLocal! !


!NmWorldMapEntryMorph methodsFor: 'event handling' stamp: 'mu 1/7/2005 01:49'!
handlesMouseDown: evt
	evt shiftPressed ifTrue: [^true].
	evt yellowButtonPressed ifTrue: [^true].
	^super handlesMouseDown: evt! !

!NmWorldMapEntryMorph methodsFor: 'event handling' stamp: 'mu 1/7/2005 01:49'!
mouseDown: evt 
	evt yellowButtonPressed ifTrue: [^self popupYellowButtonMenu: evt].
	self requestDestination
	! !


!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 1/9/2005 01:23'!
host
	mapEntry isNil ifTrue: [^nil].
	^ NetNameResolver
		nameForAddress: (NetNameResolver addressFromString: mapEntry ip)
		timeout: 30! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 1/15/2005 01:34'!
id
	mapEntry isNil ifTrue: [^''].
	^ mapEntry id! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 1/7/2005 01:47'!
ip
	mapEntry isNil ifTrue: [^''].
	^ mapEntry ip! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 1/7/2005 01:47'!
mapEntry
	^mapEntry! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 1/7/2005 01:47'!
mapEntry: aNmMapEntry
	mapEntry _ aNmMapEntry! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 1/15/2005 02:35'!
port
	mapEntry isNil ifTrue: [^0].
	^ mapEntry port asNumber! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 3/8/2005 00:34'!
rowMorph
	^ (self owner isMemberOf: NmWorldMapRowMorph)
		ifTrue: [self owner]! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'ns 9/17/2002 13:50'!
text
	^ textMorph contents asString! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 3/2/2005 00:57'!
text: destinationString 
	| dest |
	dest _ self computeDestinationFrom: destinationString asString.
	textMorph contents: dest.
	self
		extent: (textMorph extent + (borderWidth + 3) max: self defaultCellWidth @ self defaultCellHeight).
	textMorph position: bounds center - (textMorph extent // 2).
	textMorph lock.
	self setBalloonText: dest.
	self name: destinationString asString! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 1/9/2005 01:25'!
url
	mapEntry isNil ifTrue: [^nil].
	^mapEntry destination asUrl! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 4/26/2005 02:00'!
worldMapMorph
	^self ownerThatIsA: NmWorldMapMorph! !


!NmWorldMapEntryMorph methodsFor: 'initialization' stamp: 'mu 6/3/2005 02:08'!
initialize
	super initialize.
	textMorph _ TextMorph new.
	textMorph centered.
	textMorph borderColor: Color transparent.
	textMorph width: self defaultCellWidth.
	textMorph fillStyle: self defaultFillStyle.
	textMorph lock.
	self addMorphCentered: textMorph;
		 clipSubmorphs: true;
		 borderWidth: 2;
		 setBorderStyle: #complexAltInset.
	self width: self defaultCellWidth.
	self fillStyle: self defaultFillStyle.
	self text: ''! !


!NmWorldMapEntryMorph methodsFor: 'menu' stamp: 'mu 7/2/2005 12:53'!
addProjectMenuItemsTo: aMenu 
	| book |
	"self isLocal ifTrue: [^self]."
	book _ NmProjectBookMorph on: self.
	aMenu add: 'load remote project...' target: book action: #openInHand! !

!NmWorldMapEntryMorph methodsFor: 'menu' stamp: 'mu 6/20/2005 02:05'!
popupYellowButtonMenu: evt 
	| menu |
	menu _ MenuMorph new defaultTarget: self.
	(self isLocal not
			and: [NmWorldMap default localEntry isNil])
		ifTrue: [menu add: 'set as local' action: #setAsLocal].
	self exists
		ifTrue: [menu add: 'set destination name' action: #requestDestination.
			menu addLine.
			menu add: 'take a picture' action: #takeAPicture.
			self addProjectMenuItemsTo: menu.
			].
	menu popUpInWorld! !


!NmWorldMapEntryMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/10/2005 02:44'!
privateDelete
	super privateDelete.
	mapEntry removeDependent: self.! !


!NmWorldMapEntryMorph methodsFor: 'menu-actions' stamp: 'mu 4/26/2005 02:01'!
requestDestination
	| isLocal point ans |
	isLocal _ self isLocal.
	point _ self point.
	ans _ FillInTheBlank request: 'Enter a new destination name (any string)' initialAnswer: ''.
	ans isEmpty
		ifTrue: [^ self].
	(isLocal
			and: [self isBadLocalUrlName: ans])
		ifTrue: [^ PopUpMenu inform: 'The url does not match your local host and port'].
	(isLocal not
			and: [ans asUrl = NmUrl local])
		ifTrue: [^ PopUpMenu inform: 'Cannot set local url to remote'].
	((NmWorldMap default worldNamesExcluding: point)
			includes: ans)
		ifTrue: [^ PopUpMenu inform: 'Duplicate name'].
	self mapEntry
		ifNotNilDo: [:ent | ent name: ans].
	(isLocal and: [self mapEntry hasChanged])
		ifTrue: [(PopUpMenu confirm: 'Local name changed. Store now? ')
				ifTrue: [self worldMapMorph ifNotNilDo: [:wmm | wmm store]]].
	! !

!NmWorldMapEntryMorph methodsFor: 'menu-actions' stamp: 'mu 1/15/2005 02:13'!
setAsLocal
	| newId |
	newId _ self id.
	newId isEmpty
		ifFalse: [NmWorldMap default resetLocalTo: newId]! !

!NmWorldMapEntryMorph methodsFor: 'menu-actions' stamp: 'mu 6/17/2005 00:13'!
takeAPicture
	| connector form morph |
	[connector _ NmRemoteConnector connect: self ip port: self port.
	form _ connector callTakeAPicture: NmSettings pictureShrunkBySize.
	morph _SketchMorph withForm: form.
	morph addDropShadow.
	morph shadowColor: Color gray.
	morph  openInHand]
		on: RmtNetworkError
		do: [:ex | NmShortMessageMorph contents: ex messageText for: self]! !


!NmWorldMapEntryMorph methodsFor: 'stepping' stamp: 'mu 3/8/2005 01:17'!
step
	self text: self destination.
	! !


!NmWorldMapEntryMorph methodsFor: 'updating' stamp: 'mu 4/28/2005 22:36'!
update: anObject 
	(anObject isMemberOf: NmWorldMapEntry)
		ifTrue: [self resetColor.
			self rowMorph
				ifNotNilDo: [:row | row update: anObject]]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmWorldMapEntryMorph class
	instanceVariableNames: ''!

!NmWorldMapEntryMorph class methodsFor: 'scripting' stamp: 'ns 9/17/2002 15:49'!
additionsToViewerCategories
	^ #(#additionsToViewerCategoryBasic #additionsToViewerCategoryScripts #additionsToViewerCategoryColorAndBorder #additionsToViewerCategoryGeometry #additionsToViewerCategoryMiscellaneous #additionsToViewerCategoryButton #additionsToViewerCategoryMotion #additionsToViewerCategoryObservation #additionsToViewerCategoryPenUse #additionsToViewerCategoryLayout #additionsToViewerCategoryDragAndDrop #additionsToViewerCategoryScripting #additionsToViewerCategoryTests #additionsToViewerCategoryNmUrl )
		select: [:aSelector | self respondsTo: aSelector]
		thenCollect: [:aSelector | self perform: aSelector]! !

!NmWorldMapEntryMorph class methodsFor: 'scripting' stamp: 'mu 4/12/2003 19:38'!
additionsToViewerCategoryNmUrl
	"Answer viewer additions for the 'URL' category"

	^#(
		URL 
		(
"			(slot url 'url' String	readWrite Player getUrl Player setUrl:)"
			(slot host 'host' String	readWrite Player getAuthority Player setAuthority:)
"			(slot path 'path' String	readWrite Player getPath Player setPath:)"
			(slot port 'port' Number readWrite Player getPort Player  setPort:)
			(slot ipAddress 'ip address' String readOnly Player getIpAddress unused  unused)
		)
	)
! !

!NmWorldMapEntryMorph class methodsFor: 'scripting' stamp: 'mu 4/12/2003 19:39'!
additionsToViewerCategoryNmUrlDeluxe
	"Answer viewer additions for the 'URL' category"

	^#(
		URL 
		(
			(slot url 'url' String	readWrite Player getUrl Player setUrl:)
			(slot fragment 'fragment' String	readWrite Player getFragment Player setFragment:)
			(slot scheme 'scheme' String	readWrite Player getScheme Player setScheme:)
			(slot host 'host' String	readWrite Player getAuthority Player setAuthority:)
			(slot path 'path' String	readWrite Player getPath Player setPath:)
			(slot query 'query' String	readWrite Player getQuery Player setQuery:)
			(slot port 'port' Number readWrite Player getPort Player  setPort:)
			(slot realm 'realm' String	readWrite Player getRealm Player setRealm:)
		)
	)
! !


!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'mu 1/14/2005 02:02'!
defaultCellHeight
	^ 50! !

!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'mu 4/29/2005 19:33'!
defaultCellWidth
	^ 81! !

!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'mu 3/16/2005 01:20'!
defaultColor
	^ Color white darker! !

!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'mu 3/16/2005 01:00'!
defaultEditedColor
	^ Color red! !

!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'mu 3/16/2005 01:19'!
defaultExistsColor
	^ Color tan! !

!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'mu 3/16/2005 01:37'!
defaultLocalColor
	^ Color cyan! !

!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'ns 9/17/2002 17:13'!
defaultMapColor
	^ Color lightGray! !

!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'mu 3/16/2005 01:37'!
defaultVacantColor
	^ Color darkGray! !


StringMorph subclass: #NmWorldMapInfoMorph
	instanceVariableNames: 'worldMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-WorldMap'!

!NmWorldMapInfoMorph methodsFor: 'private' stamp: 'mu 7/2/2005 00:46'!
localInfoString
	| map localNameInfo localPointInfo |
	map _ self worldMap.
	map isLocal ifFalse:[^''].
	localNameInfo _ '[', map localName asString,']'.
	localPointInfo _ '@[', map localPoint asString, ']'.
	^localNameInfo, localPointInfo! !


!NmWorldMapInfoMorph methodsFor: 'stepping and presenter' stamp: 'mu 7/2/2005 00:48'!
step
	self contents: self localInfoString , ': ', self worldMap mapName.

! !

!NmWorldMapInfoMorph methodsFor: 'stepping and presenter' stamp: 'mu 5/29/2003 15:14'!
stepTime
	^2000! !


!NmWorldMapInfoMorph methodsFor: 'accessing' stamp: 'mu 4/8/2005 00:12'!
worldMap
	worldMap
		ifNil: [worldMap _ self worldMapMorph
						ifNotNilDo: [:mo | mo worldMap]].
	^ worldMap! !

!NmWorldMapInfoMorph methodsFor: 'accessing' stamp: 'mu 4/8/2005 00:11'!
worldMapMorph
	^self ownerThatIsA: NmWorldMapMorph! !

!NmWorldMapInfoMorph methodsFor: 'accessing' stamp: 'mu 4/5/2005 01:43'!
worldMap: aNmWorldMap
	worldMap _ aNmWorldMap! !


NmBuilderMorph subclass: #NmWorldMapMorph
	instanceVariableNames: 'worldMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-WorldMap'!

!NmWorldMapMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 7/2/2005 00:22'!
addButtonRow
	| buttonBar |
	buttonBar _ AlignmentMorph newRow cellInset: 2;
				 hResizing:  #shrinkWrap;
				vResizing:  #shrinkWrap;
				 color: Color transparent.
	buttonBar
		addMorphBack: (self buttonName: 'Store' action: #store).
	buttonBar
		addMorphBack: (self buttonName: 'Load' action: #load).
	buttonBar
		addMorphBack: (self buttonName: 'Init' action: #initAllInfo).
	buttonBar
		addMorphBack: (self buttonName: 'Inspect' action: #inspectMap).
	buttonBar
		addMorphBack: (self buttonName: 'Close' action: #close).
	buttonBar setBorderStyle: #complexAltInset.
	buttonBar borderWidth: 4.
	self addMorphBack: buttonBar! !

!NmWorldMapMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 6/22/2005 22:46'!
addInfoRow
	| infoBar |
	infoBar _ AlignmentMorph newRow cellInset: 2;
				 hResizing: #shrinkWrap;
				 vResizing: #shrinkWrap;
				 color: Color transparent.
	infoBar addMorphBack: NmWorldMapInfoMorph new.
	infoBar setBorderStyle: #complexAltInset.
	infoBar borderWidth: 4.
	infoBar lock.
	self addMorphBack: infoBar! !

!NmWorldMapMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/29/2005 09:51'!
addMap
	| panel |
	panel _ self makePanel.
	panel load: self worldMap.
	self addMorphBack: panel! !

!NmWorldMapMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/29/2005 22:49'!
initSubmorphs
	self submorphsDo: [:each | each delete].
	self initSubPanels.
	! !

!NmWorldMapMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/29/2005 09:07'!
makePanel
	| panel |
	panel _ NmWorldMapPanelMorph inset: self defaultInset.
	panel reset.
	^ panel! !

!NmWorldMapMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/29/2005 22:47'!
privateDelete
	super privateDelete.
	self unregisterEvent.! !


!NmWorldMapMorph methodsFor: 'private' stamp: 'mu 7/5/2005 21:00'!
basicLoad
	[self worldMap load.
	self worldMap allUnchanged]
		on: Error
		do: [self inform: 'WorldMap loading failed!!'.
			^ self]! !


!NmWorldMapMorph methodsFor: 'constants' stamp: 'ka 1/10/2003 12:05'!
defaultInset
	^ self class defaultInset! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 12:21'!
defaultOwnerClass
	^ SystemWindow! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 12:22'!
minimumExtent
	| width height |
	width _ height _ 0.
	self submorphs
		do: [:each | 
			width _ width max: each extent x.
			height _ height + each extent y].
	(self owner isKindOf: self defaultOwnerClass)
		ifTrue: [height _ height + self owner labelHeight + 20.
			width _ width + 20].
	^ width @ height! !


!NmWorldMapMorph methodsFor: 'actions' stamp: 'mu 3/8/2005 01:27'!
close
	self hasChanged
		ifTrue: [(PopUpMenu confirm: 'Store to server?')
				ifTrue: [self store]].
	(self owner isKindOf: self defaultOwnerClass)
		ifTrue: [self unregisterEvent.
			self owner closeBoxHit]
		ifFalse: [self delete]! !

!NmWorldMapMorph methodsFor: 'actions' stamp: 'mu 6/3/2005 21:56'!
initAllInfo
	(PopUpMenu confirm: 'Really initialize the world map?')
		ifFalse: [^ self].
	self worldMap initMap.
	self worldMap isLocal
		ifTrue: [self worldMap
				forceRegister: (NmWorldMapEntry
						id: Smalltalk id
						point: 0 @ 0
						name: '')].
	self initSubmorphs.
	self panel
		ifNotNilDo: [:p | p borderColorEdited]! !

!NmWorldMapMorph methodsFor: 'actions' stamp: 'mu 1/14/2005 01:05'!
inspectMap
	self worldMap inspect! !

!NmWorldMapMorph methodsFor: 'actions' stamp: 'mu 4/29/2005 10:09'!
load
	(self hasChanged)
		ifTrue: [(self confirm:  'Not stored. Load anyway?') ifFalse: [^self]]. 
	self basicLoad
	! !

!NmWorldMapMorph methodsFor: 'actions' stamp: 'mu 4/29/2005 09:46'!
store
	self panelDo: [:p | p store: self worldMap]

	! !


!NmWorldMapMorph methodsFor: 'initialize-release' stamp: 'mu 4/29/2005 23:58'!
createWindow
	self initSubPanels! !

!NmWorldMapMorph methodsFor: 'initialize-release' stamp: 'mu 7/2/2005 00:17'!
initialize
	super initialize.
	self fillStyle: self backgroundFillStyle.
	self hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	borderWidth _ 2.
	self listDirection: #topToBottom.
	self cornerStyle: #square.
	self layoutInset: 4.

	self useRoundedCorners.
	! !

!NmWorldMapMorph methodsFor: 'initialize-release' stamp: 'mu 4/5/2005 01:41'!
initSubPanels
	self addButtonRow.
	self addMap.
	self addInfoRow.
	! !


!NmWorldMapMorph methodsFor: 'event handling' stamp: 'mu 5/2/2005 02:02'!
handleLoaded
	self isInWorld
		ifFalse: [^ self delete].
	self
		panelDo: [:p | p load: self worldMap]! !

!NmWorldMapMorph methodsFor: 'event handling' stamp: 'mu 4/29/2005 09:07'!
handleLocalEntryUpdated
	| loadOK |
	self isInWorld
		ifFalse: [^ self delete].
	self panel isNil
		ifTrue: [^ self].
	loadOK _ true.
	self hasChanged
		ifTrue: [loadOK _ PopUpMenu confirm: 'Updated from remote. Load anyway?'].
	loadOK
		ifTrue: [self basicLoad]! !

!NmWorldMapMorph methodsFor: 'event handling' stamp: 'mu 5/2/2005 02:02'!
handleStored
	self isInWorld
		ifFalse: [^ self delete].
	self
		panelDo: [:p | p load: self worldMap]! !

!NmWorldMapMorph methodsFor: 'event handling' stamp: 'ns 9/11/2002 18:59'!
handlesMouseDown: evt 
	^ true! !

!NmWorldMapMorph methodsFor: 'event handling' stamp: 'ka 1/10/2003 15:07'!
morphToGrab: event
	| morphs morph |
	morphs _ self morphsAt: event position.
	morphs isEmpty
		ifTrue: [^ nil].
	morph _ morphs first.
	(morph isKindOf: TextMorph)
		ifTrue: [^ morph owner].
	(morph isMemberOf: BorderedMorph)
		ifTrue: [^ morph].
	(morph isKindOf: AlignmentMorph)
		ifTrue: [(morph submorphOfClass: self defaultButtonClass) notNil
				ifTrue: [^ nil]
				ifFalse: [(morph submorphOfClass: AlignmentMorph) notNil
						ifTrue: [^ nil]
						ifFalse: [^ morph]]].
	^ nil! !

!NmWorldMapMorph methodsFor: 'event handling' stamp: 'mu 2/4/2005 00:17'!
mouseDown: evt 
	"Handle a mouse down event."
	| grabbedMorph |
	grabbedMorph _ self morphToGrab: evt.
	grabbedMorph
		ifNotNil: [| result | 
			grabbedMorph isSticky
				ifTrue: [^ self].
			result _ evt hand grabMorph: grabbedMorph.
			^ result].
	(super handlesMouseDown: evt)
		ifTrue: [^ super mouseDown: evt].
	evt hand halo: nil.
	"shake off halos"
	evt hand releaseKeyboardFocus.
	"shake of keyboard foci"
	evt shiftPressed
		ifTrue: [^ evt hand
				waitForClicksOrDrag: self
				event: evt
				selectors: {#'findWindow:'. nil. nil. #'dragThroughOnDesktop:'}
				threshold: 5].
	evt wasHandled: false! !

!NmWorldMapMorph methodsFor: 'event handling' stamp: 'mu 5/2/2005 02:08'!
registerEvent
	self worldMap when: #worldMapLoaded send: #handleLoaded to: self.
	self worldMap when: #worldMapStored send: #handleStored to: self.
	self worldMap when: #localEntryUpdated send: #handleLocalEntryUpdated to: self.
	! !

!NmWorldMapMorph methodsFor: 'event handling' stamp: 'mu 4/16/2005 00:04'!
unregisterEvent
	self worldMap removeActionsWithReceiver: self forEvent: #worldMapLoaded.
	self worldMap removeActionsWithReceiver: self forEvent: #worldMapStored.
	self worldMap removeActionsWithReceiver: self forEvent: #localEntryUpdated! !


!NmWorldMapMorph methodsFor: 'testing' stamp: 'mu 3/8/2005 01:26'!
hasChanged
	^ (self worldMap entries
			anySatisfy: [:each | each hasChanged])
		or: [self panel hasChanged]! !

!NmWorldMapMorph methodsFor: 'testing' stamp: 'mu 4/29/2005 00:00'!
mapIsLocal
	^self worldMap isLocal! !


!NmWorldMapMorph methodsFor: 'accessing' stamp: 'mu 4/29/2005 09:06'!
panel
	^self findA: NmWorldMapPanelMorph! !

!NmWorldMapMorph methodsFor: 'accessing' stamp: 'mu 4/29/2005 09:45'!
panelDo: aBlock
	^self panel ifNotNilDo: aBlock! !

!NmWorldMapMorph methodsFor: 'accessing' stamp: 'mu 4/16/2005 00:09'!
setWorldMap: aNmWorldMap
	self worldMap: aNmWorldMap.
	self registerEvent.! !

!NmWorldMapMorph methodsFor: 'accessing' stamp: 'mu 3/4/2005 01:16'!
worldMap
	worldMap isNil
		ifTrue: [worldMap _ NmWorldMap default].
	^ worldMap! !

!NmWorldMapMorph methodsFor: 'accessing' stamp: 'mu 3/4/2005 01:15'!
worldMap: aNmWorldMap
	worldMap _ aNmWorldMap! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmWorldMapMorph class
	instanceVariableNames: ''!

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'mu 4/30/2005 00:00'!
createWindow
	| insts inst |
	insts _ self existingOn: NmWorldMap default.
	inst _ insts isEmpty
				ifTrue: [self new createWindow]
				ifFalse: [insts first].
	inst registerEvent.
	^ inst! !

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'mu 4/29/2005 23:56'!
existingOn: aNmWorldMap
	| existing |
	existing _ ActiveWorld submorphs
				select: [:each | (each isKindOf: NmWorldMapMorph)
						and: [each worldMap = aNmWorldMap]].
	^existing! !

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'mu 3/4/2005 01:19'!
open
	^self openOn: NmWorldMap default! !

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'mu 4/16/2005 00:07'!
openOn: aWorldMap 
	"self openOn: NmWorldMap new"
	^ self new setWorldMap: aWorldMap;
		 createWindow;
		 openInWorld! !

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'mu 4/29/2005 23:56'!
openSingleOn: aNmWorldMap
	| world existing |
	world _ ActiveWorld.
	existing _ self existingOn: aNmWorldMap.
	existing isEmpty
		ifTrue: [(self openOn: aNmWorldMap) center: world center]
		ifFalse: [ world addMorphFront: existing first.
			"existing first center:  world center"]! !


!NmWorldMapMorph class methodsFor: 'constants' stamp: 'ka 1/10/2003 12:26'!
defaulfRowExtent
	^ 93 @ 58! !

!NmWorldMapMorph class methodsFor: 'constants' stamp: 'ka 1/10/2003 12:05'!
defaultInset
	^ 16! !


AlignmentMorph subclass: #NmWorldMapPanelMorph
	instanceVariableNames: 'lastDescriptionString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-WorldMap'!

!NmWorldMapPanelMorph methodsFor: 'constants' stamp: 'mu 6/4/2004 23:18'!
backgroundColor
	^ Color gray: 0.9! !

!NmWorldMapPanelMorph methodsFor: 'constants' stamp: 'mu 3/16/2005 01:08'!
defaultConflictsColor
	^ Color yellow! !

!NmWorldMapPanelMorph methodsFor: 'constants' stamp: 'mu 3/16/2005 01:08'!
defaultEditedColor
	^ Color red! !

!NmWorldMapPanelMorph methodsFor: 'constants' stamp: 'mu 3/17/2005 00:59'!
defaultFillStyle
	| fill |
	fill _ GradientFillStyle ramp: {0.0 -> (Color
							r: 0.9
							g: 0.9
							b: 0.9). 1.0
					-> (Color
							r: 0.46
							g: 0.86
							b: 0.86)}.
	fill origin: self bounds topLeft + (4 @ 10).
	fill direction: 50 @ 6.
	fill radial: false.
	^ fill! !

!NmWorldMapPanelMorph methodsFor: 'constants' stamp: 'mu 3/16/2005 01:01'!
defaultNotStoredColor
	^ Color red! !


!NmWorldMapPanelMorph methodsFor: 'actions' stamp: 'mu 5/8/2005 23:01'!
basicLoad: aNmWorldMap 
	| points yValues minY maxY xValues minX maxX |
	self submorphsDo:[:each | each delete].
	points _ aNmWorldMap allPoints.
	yValues _ points
				collect: [:each | each y].
	yValues isEmpty ifTrue: [^self].
	minY _ yValues min.
	maxY _ yValues max.
	xValues _ points
				collect: [:each | each x].
	xValues isEmpty ifTrue: [^self].
	minX _ xValues min.
	maxX _ xValues max.
	minY
		to: maxY
		do: [:idxY | 
			| row existingCells | 
			row _ self makeRow.
			self addMorph: row.
			existingCells _ points
						select: [:each | each y = idxY].
			existingCells isEmpty
				ifFalse: [minX
						to: maxX
						do: [:idxX | 
							| destMorph destEntry | 
							destMorph _ NmWorldMapEntryMorph new.
							row addMorphBack: destMorph.
							destEntry _ aNmWorldMap atPoint: idxX @ idxY.
							destMorph setEntry: destEntry].
					row reset]].
	! !

!NmWorldMapPanelMorph methodsFor: 'actions' stamp: 'mu 3/16/2005 01:09'!
borderColorEdited
	self borderColor: self defaultEditedColor! !

!NmWorldMapPanelMorph methodsFor: 'actions' stamp: 'mu 5/4/2005 17:40'!
load: aNmWorldMap 
	| entries |
	entries _ aNmWorldMap entries.
	entries isEmpty
		ifTrue: [self inform: 'WorldMap is empty!! Use "save as neighbors"'.
			^ self].
	WorldState
		addDeferredUIMessage: [self basicLoad: aNmWorldMap.
			self resetColor]! !

!NmWorldMapPanelMorph methodsFor: 'actions' stamp: 'mu 4/14/2005 00:47'!
reset
	self resetColor.
	self rows
		do: [:e | e reset]! !

!NmWorldMapPanelMorph methodsFor: 'actions' stamp: 'mu 4/14/2005 00:48'!
resetColor
	self resetBorderColor! !

!NmWorldMapPanelMorph methodsFor: 'actions' stamp: 'mu 4/29/2005 09:44'!
store: aWorldMap
	| panelSize rows entries |
	panelSize _ self rows size.
	rows _ self rows reverse.
	entries _ OrderedCollection new.
	1
		to: panelSize
		do: [:y | 
			| cells cellSize | 
			cells _ (rows at: y) cells.
			cellSize _ cells size.
			1
				to: cellSize
				do: [:x | 
					| destinationMorph point | 
					destinationMorph _ cells at: x.
					point _ x @ y - (1 @ 1).
					destinationMorph exists
						ifTrue: [| entry | 
							entry _ destinationMorph mapEntry.
							entry isNil
								ifFalse: [entries add: (entry point: point)]]]].
	aWorldMap initWithEntries: entries.
	aWorldMap store. 

	! !


!NmWorldMapPanelMorph methodsFor: 'updating' stamp: 'mu 4/28/2005 23:22'!
basicUpdate: anObject 
	self resetColor.
	! !

!NmWorldMapPanelMorph methodsFor: 'updating' stamp: 'mu 4/14/2005 00:34'!
update: anObject 
	(anObject isMemberOf: NmWorldMapRowMorph)
		ifTrue: [self basicUpdate: anObject.
			lastDescriptionString _ nil]! !


!NmWorldMapPanelMorph methodsFor: 'private' stamp: 'mu 4/27/2005 01:49'!
computeColor
	self mapMorph ifNil: [^self backgroundColor].
	^self mapMorph hasChanged
		ifTrue: [self defaultEditedColor]
		ifFalse: [self backgroundColor]! !

!NmWorldMapPanelMorph methodsFor: 'private' stamp: 'mu 4/14/2005 00:39'!
resetBorderColor
	self borderColor: self computeColor! !


!NmWorldMapPanelMorph methodsFor: 'describing state' stamp: 'mu 1/23/2005 05:03'!
descriptionString
	^self rows inject: String new into: [:inj :each | inj, each descriptionString]! !

!NmWorldMapPanelMorph methodsFor: 'describing state' stamp: 'mu 3/15/2005 01:10'!
lastDescriptionString
	lastDescriptionString
		ifNil: [lastDescriptionString _ self descriptionString].
	^ lastDescriptionString! !


!NmWorldMapPanelMorph methodsFor: 'testing' stamp: 'mu 3/15/2005 01:06'!
hasChanged
	^ (self rows
			anySatisfy: [:each | each hasChanged])
		or: [| currentDescriptionString | 
			currentDescriptionString _ self descriptionString.
			currentDescriptionString ~= self lastDescriptionString]! !


!NmWorldMapPanelMorph methodsFor: 'initialize-release' stamp: 'mu 3/17/2005 00:55'!
initialize
	super initialize.
	self fillStyle: self defaultFillStyle! !


!NmWorldMapPanelMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/29/2005 09:52'!
makeRow
	"self basicNew makeRow openInHand"
	| row |
	row _ NmWorldMapRowMorph newRow.
	^ row! !

!NmWorldMapPanelMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/14/2005 00:31'!
privateAddMorph: aMorph atIndex: index 
	self lastDescriptionString.
	super privateAddMorph: aMorph atIndex: index.
	self basicUpdate: self! !


!NmWorldMapPanelMorph methodsFor: 'accessing' stamp: 'mu 4/14/2005 00:50'!
mapMorph
	^ (self owner isMemberOf: NmWorldMapMorph)
		ifTrue: [self owner]! !

!NmWorldMapPanelMorph methodsFor: 'accessing' stamp: 'mu 12/31/2004 04:55'!
rows
	^self submorphs select: [:each | each isKindOf: NmWorldMapRowMorph]! !


!NmWorldMapPanelMorph methodsFor: 'dropping/grabbing' stamp: 'mu 5/19/2003 13:40'!
wantsDroppedMorph: aMorph event: evt
	^aMorph isKindOf: NmWorldMapRowMorph! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmWorldMapPanelMorph class
	instanceVariableNames: ''!

!NmWorldMapPanelMorph class methodsFor: 'instance creation' stamp: 'mu 3/16/2005 23:57'!
inset: inset
	| inst |
	inst _ self newColumn.
	inst cellInset: inset;
		 layoutInset: inset.
	inst enableDragNDrop; vResizing: #shrinkWrap; hResizing: #shrinkWrap; layoutInset: inset; borderColor: Color black; borderWidth: 1; wrapCentering: #left; cellPositioning: #topLeft.
	inst borderWidth: 4.
	^ inst! !


AlignmentMorph subclass: #NmWorldMapRowMorph
	instanceVariableNames: 'lastDescriptionString destinationEdited'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-WorldMap'!

!NmWorldMapRowMorph methodsFor: 'updating' stamp: 'mu 3/17/2005 01:20'!
basicUpdate: anObject 
	self resetColor.
	self panel
		ifNotNilDo: [:p | p update: self]! !

!NmWorldMapRowMorph methodsFor: 'updating' stamp: 'mu 4/10/2005 03:51'!
update: anObject 
	(anObject isMemberOf: NmWorldMapEntry)
		ifTrue: [destinationEdited _ anObject hasChanged.
			destinationEdited ifFalse: [lastDescriptionString _ self descriptionString].
			self basicUpdate: self]! !


!NmWorldMapRowMorph methodsFor: 'accessing' stamp: 'mu 4/8/2005 00:17'!
cells
	^self submorphs select: [:each | each isKindOf: NmWorldMapEntryMorph]! !

!NmWorldMapRowMorph methodsFor: 'accessing' stamp: 'mu 3/17/2005 01:11'!
panel
	^ (self owner isMemberOf: NmWorldMapPanelMorph)
		ifTrue: [self owner]! !


!NmWorldMapRowMorph methodsFor: 'private' stamp: 'mu 4/14/2005 00:39'!
computeColor
	^self hasChanged
		ifTrue: [NmWorldMapEntryMorph defaultEditedColor]
		ifFalse: [self defaultColor]! !

!NmWorldMapRowMorph methodsFor: 'private' stamp: 'mu 4/14/2005 00:39'!
resetBorderColor
	self borderColor: self computeColor! !

!NmWorldMapRowMorph methodsFor: 'private' stamp: 'mu 3/17/2005 01:09'!
resetColor
	self resetBorderColor! !


!NmWorldMapRowMorph methodsFor: 'constants' stamp: 'mu 3/16/2005 01:27'!
defaultColor
	^Color lightGray lighter! !

!NmWorldMapRowMorph methodsFor: 'constants' stamp: 'mu 3/16/2005 23:50'!
defaultFillStyle
	| fill |
	fill _ GradientFillStyle ramp: {0.0
					-> (Color
							r: 0.7
							g: 0.7
							b: 0.7). 1.0
					-> (Color
							r: 0.5
							g: 0.6
							b: 0.7)}.
	fill origin: self bounds topLeft + (20 @ 30).
	fill direction: 30 @ 9.
	fill radial: false.
	^ fill! !


!NmWorldMapRowMorph methodsFor: 'describing state' stamp: 'mu 2/3/2005 23:36'!
descriptionString
	self cells isEmpty ifTrue: [^''].
	^self cells inject: String new into: [:inj :each | inj, each descriptionString]! !

!NmWorldMapRowMorph methodsFor: 'describing state' stamp: 'mu 4/10/2005 03:02'!
lastDescriptionString
	lastDescriptionString
		ifNil: [lastDescriptionString _ self descriptionString].
	^ lastDescriptionString! !


!NmWorldMapRowMorph methodsFor: 'testing' stamp: 'mu 3/8/2005 01:25'!
destinationEdited
	destinationEdited ifNil: [destinationEdited _ false].
	^destinationEdited! !

!NmWorldMapRowMorph methodsFor: 'testing' stamp: 'mu 3/8/2005 01:12'!
hasChanged
	^ self destinationEdited
		or: [self layoutEdited]! !

!NmWorldMapRowMorph methodsFor: 'testing' stamp: 'mu 4/10/2005 03:48'!
layoutEdited
	| currentDescriptionString |
	currentDescriptionString _ self descriptionString.
	^currentDescriptionString ~= self lastDescriptionString! !


!NmWorldMapRowMorph methodsFor: 'initialization' stamp: 'mu 4/10/2005 03:32'!
initialize
	super initialize.
	self fillStyle: self defaultFillStyle.
	! !

!NmWorldMapRowMorph methodsFor: 'initialization' stamp: 'mu 4/14/2005 00:47'!
reset
	lastDescriptionString _ nil.
	destinationEdited _ false.
	self resetColor! !


!NmWorldMapRowMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/10/2005 03:19'!
privateAddMorph: aMorph atIndex: index 
	self lastDescriptionString.
	super privateAddMorph: aMorph atIndex: index.
	self basicUpdate: self! !

!NmWorldMapRowMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/25/2005 00:25'!
privateRemove: aMorph 
	super privateRemove: aMorph.
	self lastDescriptionString.
	self basicUpdate: self! !


!NmWorldMapRowMorph methodsFor: 'stepping' stamp: 'mu 4/10/2005 03:34'!
step
	self cells isEmpty
		ifTrue: [self borderColor: self defaultColor.
			self extent: self class defaulfExtent]! !

!NmWorldMapRowMorph methodsFor: 'stepping' stamp: 'mu 4/10/2005 03:26'!
stepTime
	^2000! !


!NmWorldMapRowMorph methodsFor: 'dropping/grabbing' stamp: 'mu 4/8/2005 00:17'!
wantsDroppedMorph: aMorph event: evt
	^aMorph isKindOf: NmWorldMapEntryMorph! !

!NmWorldMapRowMorph methodsFor: 'dropping/grabbing' stamp: 'mu 1/22/2005 02:50'!
wantsToBeDroppedInto: aMorph 
	(aMorph isKindOf: TrashCanMorph) ifTrue: [^true].
	(aMorph isKindOf: self class) ifTrue: [^false].
	^false
		! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmWorldMapRowMorph class
	instanceVariableNames: ''!

!NmWorldMapRowMorph class methodsFor: 'constants' stamp: 'mu 4/10/2005 03:33'!
defaulfExtent
	^ 60 @ 30! !

!NmWorldMapRowMorph class methodsFor: 'constants' stamp: 'mu 4/8/2005 00:56'!
defaultInset
	^ 16! !


!NmWorldMapRowMorph class methodsFor: 'instance creation' stamp: 'mu 4/8/2005 00:57'!
newRow
	| row |
	row _ super newRow.
	row enableDragNDrop; vResizing: #shrinkWrap; hResizing: #shrinkWrap; layoutInset: 8; borderWidth: 2; wrapCentering: #left; cellPositioning: #topLeft.
	row cellInset: self defaultInset;
		 layoutInset: self defaultInset.
	row extent: self defaulfExtent.
	row borderColor: Color transparent.
	^ row! !
