'From Squeak3.8 of ''5 May 2005'' [latest update: #6665] on 6 July 2005 at 2:47:27 am'!

!Object methodsFor: '*NetMorph-testing' stamp: 'mu 5/10/2005 20:25'!
isNmUrl
	^false! !


!PluggableTextMorph methodsFor: '*NetMorph-override-model access' stamp: 'ka 2/25/2003 18:37'!
getText
	"Retrieve the current model text"
	| newText modelValue |
	getTextSelector == nil
		ifTrue: [^ Text new].
	modelValue _ model perform: getTextSelector.
	newText _ (modelValue respondsTo: #asText)
				ifTrue: [modelValue asText]
				ifFalse: [modelValue asString asText].
	^ newText shallowCopy! !


!String methodsFor: '*NetMorph-converting' stamp: 'mu 1/12/2005 01:43'!
asNmUrl
	^ (self beginsWith: NmUrl protocolIdentifier)
		ifTrue: [self asUrl]
		ifFalse: [NmUrl readFrom: self readStream]! !

!String methodsFor: '*NetMorph-testing' stamp: 'mu 1/12/2005 01:40'!
isIpAndPortString
	"'123.2.3.4:30' isIpAndPortString"
	"'qwerty:30' isIpAndPortString"
	"'nm://123.2.3.499:30' isIpAndPortString"
	| index ipOrHostPart isIp portPart |
	(self occurrencesOf: $: ) = 1 ifFalse: [^false].
	index _ self indexOf: $:.
	ipOrHostPart _ self copyFrom: 1  to: index -1.
	isIp _ (NetNameResolver addressFromString: ipOrHostPart) notNil.
	(isIp isNil and: [isIp occurrencesOf: $.]) ifTrue: [^false].
	portPart _ self copyFrom: index +1 to: self size.
	portPart isAllDigits ifFalse: [^false].
	^true! !

!String methodsFor: '*NetMorph-testing' stamp: 'mu 1/12/2005 01:40'!
isNmUrlString
	^ (self beginsWith: NmUrl protocolIdentifier)
		or: [self isIpAndPortString]! !


!Url methodsFor: '*NetMorph-testing' stamp: 'mu 4/15/2003 16:39'!
isNmUrl
	^false! !


!Url class methodsFor: '*NetMorph-override-parsing' stamp: 'mu 12/29/2004 22:51'!
absoluteFromText: aString
	"Url absoluteFromText: 'http://chaos.resnet.gatech.edu:8000/docs/java/index.html?A%20query%20#part'" 
	"Url absoluteFromText: 'msw://chaos.resnet.gatech.edu:9000/testbook?top'"
	"Url absoluteFromText: 'telnet:chaos.resnet.gatech.edu'"
	"Url absoluteFromText: 'file:/etc/passwd'"
	"Url absoluteFromText: 'nm://dvorak/auau'" 

	| remainder scheme fragment ind newUrl |

	"trim surrounding whitespace"
	remainder _ aString withBlanksTrimmed.	

	"extract the fragment, if any"
	ind _ remainder indexOf: $#.
	ind > 0 ifTrue: [
		fragment _ remainder copyFrom: ind+1 to: remainder size.
		remainder _ remainder copyFrom: 1 to: ind-1 ].

	"choose class based on the scheme name, and let that class do the bulk of the parsing"
	scheme _ self schemeNameForString: remainder.

	scheme = nil ifTrue: [
		newUrl _ HttpUrl new privateInitializeFromText: remainder ].

	(scheme = 'http') ifTrue: [ newUrl _ HttpUrl new privateInitializeFromText: remainder ].
	(scheme = 'msw') ifTrue: [ newUrl _ MswUrl new privateInitializeFromText: remainder ]. 
	(scheme = 'ftp') ifTrue:[ newUrl _ FtpUrl new privateInitializeFromText: remainder ].
	(scheme = 'file') ifTrue: [newUrl _ FileUrl new privateInitializeFromText: remainder ].
	
	(scheme = NmUrl scheme) ifTrue: [newUrl _ NmUrl new privateInitializeFromText: remainder ].
	
	(scheme = 'browser') ifTrue: [ newUrl _ BrowserUrl new privateInitializeFromText: remainder ].
	(scheme = 'mailto') ifTrue: [ newUrl _ MailtoUrl new privateInitializeFromText: remainder ].
	(scheme = 'sqpkg' and: [Smalltalk includesKey: #KomPackageUrl]) ifTrue: 
		[newUrl _ (Smalltalk at: #KomPackageUrl) new privateInitializeFromText: remainder].
	(scheme = 'sqmap' and: [Smalltalk includesKey: #KomSqueakMapUrl]) ifTrue: 
		[newUrl _ (Smalltalk at: #KomSqueakMapUrl) new privateInitializeFromText: remainder].

	newUrl ifNil: [  newUrl _ GenericUrl new privateInitializeFromText: remainder ].


	"set the fragment"
	newUrl privateFragment: fragment.


	"all done"
	^newUrl! !

