Object subclass: #NmAbstractInitializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmAbstractInitializer class
	instanceVariableNames: ''!

!NmAbstractInitializer class methodsFor: 'class initialization' stamp: 'mu 12/24/2004 00:12'!
initialize
	"NmAbstractInitializer initialize"
	self == NmAbstractInitializer
		ifTrue: [self initializeAll]
		ifFalse: [Smalltalk addToStartUpList: self.
			Smalltalk addToShutDownList: self]! !

!NmAbstractInitializer class methodsFor: 'class initialization' stamp: 'mu 12/24/2004 00:11'!
initializeAll
	"self initializeAll"
	self allSubclassesDo: [:each | each initialize]! !

!NmAbstractInitializer class methodsFor: 'class initialization' stamp: 'mu 12/24/2004 00:11'!
obsolete
	self == NmAbstractInitializer
		ifFalse: [Smalltalk removeFromStartUpList: self.
			Smalltalk removeFromShutDownList: self]! !


!NmAbstractInitializer class methodsFor: 'system shutdown' stamp: 'mu 12/24/2004 00:10'!
shutDown
	! !


!NmAbstractInitializer class methodsFor: 'system startup' stamp: 'mu 12/24/2004 00:10'!
startUp
	! !


Model subclass: #NmBaseSettings
	instanceVariableNames: ''
	classVariableNames: 'Properties'
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmBaseSettings class
	instanceVariableNames: ''!

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 6/1/2005 00:40'!
autoTrimMapServers
	"self autoTrimMapServers"
	^ self properties at: #autoTrimMapServers ifAbsentPutValue: true! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 6/1/2005 00:40'!
autoTrimMapServers: boolean 
	boolean == self autoTrimMapServers
		ifTrue: [^ self].
	self properties at: #autoTrimMapServers put: boolean == true.
	! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 6/2/2005 22:50'!
explicitGlobalAddress
	^ self properties at: #explicitGlobalAddress ifAbsentPutValue: nil! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 5/12/2005 23:30'!
explicitGlobalAddress: ipAddressString 
	"NmSettings explicitGlobalAddress: '123.2.4.5'"
	"NmSettings explicitGlobalAddress: ''"
	| correctAddress correctAddressString |
	ipAddressString
		ifNil: [self properties at: #explicitGlobalAddress put: nil.
			self changed: #explicitGlobalAddress.
			^ true].
	correctAddress _ NetNameResolver addressFromString: ipAddressString.
	correctAddress isNil
		ifTrue: [self error: 'Invalid IP address:' , ipAddressString.
			^ false].
	correctAddressString _ NetNameResolver stringFromAddress: correctAddress.
	self properties at: #explicitGlobalAddress put: correctAddressString.
	self changed: #explicitGlobalAddress.
	^ true! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 6/13/2005 22:26'!
mapFromInternet
	^ self properties at: #mapFromInternet ifAbsentPutValue: false! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 6/13/2005 22:26'!
mapFromInternet: aBoolean 
	 self properties at: #mapFromInternet put: aBoolean! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 3/10/2003 18:15'!
mapPath
	| mapPath |
	mapPath _ self properties
				at: #mapPath
				ifAbsent: [].
	(mapPath isNil
			or: [mapPath isEmpty])
		ifTrue: [mapPath _ self properties at: #mapPath put: self defaultMapPath].
	^ mapPath! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 3/10/2003 18:16'!
mapPath: aValue 
	(aValue isNil
			or: [aValue asString isEmpty])
		ifTrue: [^ false].
	self properties at: #mapPath put: aValue asString.
	self changed: #mapPath.
	^ true! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 5/30/2005 23:55'!
mapServerUrl
	"NmBaseSettings mapServerUrl"
	^ self properties at: #mapServerUrl ifAbsentPutValue: self defaultMapServerUrl! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 5/29/2005 03:15'!
mapServerUrl: aValue 
	self properties at: #mapServerUrl put: aValue asString.
	self changed: #mapServerUrl.
	^ true! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 5/12/2005 23:58'!
properties
	Properties ifNil: [Properties _ NmProperties new].
	^Properties! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 6/3/2005 14:32'!
warpPort
	^ self properties at: #warpPort ifAbsentPutValue: self defaultWarpPort! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 6/3/2005 14:32'!
warpPort: aValue 
	"NmSettings warpPort: 37459"
	"NmSettings warpPort: 40000." "<-Not allowed"
	| aNumber |
	[aNumber _ aValue asNumber]
		on: Error
		do: [^ false].
	(self availableWarpPorts  rangeIncludes: aNumber) ifFalse: [aNumber _ self defaultWarpPort] .
	self warpPort = aNumber ifTrue: [^true].
	self properties at: #warpPort put: aNumber.
	self changed: #warpPort with: aNumber.
	self initializeForNet.
	^ true! !


!NmBaseSettings class methodsFor: 'actions' stamp: 'mu 6/3/2005 03:20'!
availableWarpPorts
	^self defaultWarpPort to: self defaultWarpPort + self defaultWarpPortRange -1.! !


!NmBaseSettings class methodsFor: 'changing' stamp: 'mu 6/3/2005 20:06'!
changed: anAspect
	super changed: anAspect.
	self subclasses do: [:e | e changed: anAspect].
	! !

!NmBaseSettings class methodsFor: 'changing' stamp: 'mu 6/3/2005 20:11'!
changed: anAspect with: param
	super changed: anAspect with: param.
	self subclasses do: [:e | e changed: anAspect with: param].
	! !

!NmBaseSettings class methodsFor: 'changing' stamp: 'mu 6/3/2005 20:11'!
changed: anAspect with: param with: param2
	super changed: anAspect with: param with: param2.
	self subclasses do: [:e | e changed: anAspect with: param with: param2].
	! !


!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/1/2005 17:16'!
defaultExternalMapServerPort
	^ 80! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/13/2005 22:09'!
defaultExternalMapServerUrl
	"self defaultExternalMapServerUrl"
	^ 'http://swikis.ddo.jp:8823/', self defaultMapServerTargetName.! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 4/28/2005 21:56'!
defaultMapPath
	| subDirName homeDir |
	subDirName _ 'worldMaps'.
	homeDir _ FileDirectory default.
	homeDir assureExistenceOfPath: subDirName.
	^homeDir fullPathFor: subDirName

! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/1/2005 17:14'!
defaultMapServerPort
	^ self notUsedPort! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 5/29/2005 03:11'!
defaultMapServerTargetName
	^'NetMorphMapServer'! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/13/2005 22:07'!
defaultMapServerUrl
	"self defaultMapServerUrl"
	^ 'http://MapServer:8823/', self defaultMapServerTargetName.! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/3/2005 03:20'!
defaultWarpPort
	^ 37458! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/3/2005 03:25'!
defaultWarpPortOffset
	^ 100! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/3/2005 03:26'!
defaultWarpPortRange
	^ 6! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/15/2005 23:54'!
iniFileName
	"self iniFileName"
	| imageName |
	imageName _ NmBaseUtil shortImageName.
	imageName _ imageName copyReplaceAll: 'image' with: 'NetMorph'.
	^imageName, '.ini'! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'my 4/9/2003 22:21'!
resolverPrefix
	^'RESOLVER_' copy! !


!NmBaseSettings class methodsFor: 'class initialization' stamp: 'mu 5/29/2005 03:26'!
initialize
	"NmBaseSettings initialize"
	Properties _ nil.
	self resetDefaults! !

!NmBaseSettings class methodsFor: 'class initialization' stamp: 'mu 6/3/2005 19:43'!
initializeForNet

	NmUrl initialize.
	NmWorldMap default localEntry ifNotNilDo: [:ent | ent resetLocalPort: self warpPort].
	NmServerManager startWarpServer.
	Smalltalk at: #NmWorldMapLocationListener ifPresent:[:p | p default start].! !

!NmBaseSettings class methodsFor: 'class initialization' stamp: 'kuri-t 2/20/2003 16:13'!
resetDefaults
	| keys |
	keys _ self properties keys.
	keys
		do: [:eachKey | self properties removeKey: eachKey].
	keys
		do: [:eachKey | self perform: #changed: with: eachKey asSymbol]! !


!NmBaseSettings class methodsFor: 'storing/loading' stamp: 'mu 6/15/2005 23:35'!
load
	"NmBaseSettings load"
	| loaded |
	loaded _ NmBaseUtil loadFrom: FileDirectory default named: self iniFileName.
	loaded notNil
		ifTrue: [Properties _ loaded.
			NmTranscript crShow: '## NmSetting was loaded: ' , self iniFileName]! !

!NmBaseSettings class methodsFor: 'storing/loading' stamp: 'mu 6/15/2005 23:38'!
store
	"NmBaseSettings store"
	NmBaseUtil
		store: self properties
		to: FileDirectory default
		named: self iniFileName! !


!NmBaseSettings class methodsFor: 'private' stamp: 'mu 6/3/2005 03:31'!
notUsedPort
	"NmBaseSettings notUsedPort"
	[| so po | 
	so _ Socket newUDP.
	so setPort: Socket wildcardPort.
	po _ so port.
	so close.
	^ po]
		on: Error
		do: [:ex | ^ self defaultExternalMapServerPort]! !


Object subclass: #NmBaseUtil
	instanceVariableNames: ''
	classVariableNames: 'PlatformSymbol'
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmBaseUtil class
	instanceVariableNames: ''!

!NmBaseUtil class methodsFor: 'class initialization' stamp: 'mu 5/12/2005 23:03'!
initialize
	"NmBaseUtil initialize"
	PlatformSymbol _ nil.
	Smalltalk addToStartUpList: self.
	! !

!NmBaseUtil class methodsFor: 'class initialization' stamp: 'mu 5/12/2005 22:59'!
obsolete
	"NmBaseUtil obsolete"

	Smalltalk removeFromStartUpList: self.
	! !


!NmBaseUtil class methodsFor: 'adapter for Network' stamp: 'mu 5/13/2005 00:02'!
ipAndPortFromString: aString 
	"NmBaseUtil ipAndPortFromString: 'aaa:9090'"
	"NmBaseUtil ipAndPortFromString: 'aaaa'"
	"NmBaseUtil ipAndPortFromString: 'nm://aaaa'"
	"NmBaseUtil ipAndPortFromString: 'nm://aaaa:99'"
	| port tokens hostIndex host |
	(aString isEmptyOrNil)ifTrue: [^ nil].

	tokens _ aString findTokens: '/:'.
	port _ tokens detect: [:each | each isAllDigits] ifNone: [NmSettings defaultWarpPort asString].
	hostIndex _ tokens indexOf: port.
	host _ hostIndex = 0 ifTrue: [tokens last] ifFalse: [tokens at: (hostIndex -1)].
	
	^Array with: host with: port asNumber! !

!NmBaseUtil class methodsFor: 'adapter for Network' stamp: 'mu 5/29/2005 03:41'!
localAddress
	"NmBaseUtil localAddress"
	^ NmBaseSettings explicitGlobalAddress isNil
		ifTrue: [NetNameResolver localAddressString]
		ifFalse: [NmBaseSettings explicitGlobalAddress]! !

!NmBaseUtil class methodsFor: 'adapter for Network' stamp: 'mu 5/13/2005 00:02'!
localHostname
	"Squeak specific"
	"NmBaseUtil localHostname"
	| localHostname |
	localHostname _ NetNameResolver nameForAddress: NetNameResolver localHostAddress timeout: 10.
	localHostname isNil ifTrue: [^self localAddress].
	^ localHostname! !

!NmBaseUtil class methodsFor: 'adapter for Network' stamp: 'mu 6/15/2005 00:26'!
localMapServerUrl
	"NmBaseUtil localMapServerUrl"
	NmServerManager isMapServerInstalled
		ifFalse: [^ NmBaseSettings defaultMapServerUrl].
	^ 'http://' , self localAddress , ':' , NmServerSettings mapServerPort asString , '/' , NmBaseSettings defaultMapServerTargetName! !


!NmBaseUtil class methodsFor: 'testing' stamp: 'mu 6/15/2005 23:35'!
isSixxInstalled
	^Smalltalk includesKey: #SixxXmlUtil! !


!NmBaseUtil class methodsFor: 'storing/loading' stamp: 'mu 6/21/2005 00:31'!
loadDataFrom: stream 
	^ (self isSixxInstalled
			or: [stream peek = $<])
		ifTrue: [Object readSixxFrom: stream contents]
		ifFalse: [stream binary.
			ReferenceStream unStream: stream contents]! !

!NmBaseUtil class methodsFor: 'storing/loading' stamp: 'mu 6/21/2005 00:32'!
loadFrom: dir named: fileName 
	| readFileStream loaded |
	(dir fileExists: fileName)
		ifFalse: [^ nil].
	[readFileStream _ dir readOnlyFileNamed: fileName.
	loaded _ self loadDataFrom: readFileStream]
		ensure: [readFileStream ifNotNilDo: [:str | str close]].
	^ loaded! !

!NmBaseUtil class methodsFor: 'storing/loading' stamp: 'mu 6/21/2005 00:32'!
storeData: obj to: stream 
	self isSixxInstalled
		ifTrue: [stream nextPutAll: obj sixxString]
		ifFalse: [stream binary;
				nextPutAll: (ReferenceStream streamedRepresentationOf: obj)]! !

!NmBaseUtil class methodsFor: 'storing/loading' stamp: 'mu 6/21/2005 00:32'!
store: obj to: dir named: fileName 
	| writeFileStream |
	[writeFileStream _ dir forceNewFileNamed: fileName.
	self storeData: obj to: writeFileStream]
		ensure: [writeFileStream notNil
				ifTrue: [writeFileStream close]]! !


!NmBaseUtil class methodsFor: 'system' stamp: 'mu 5/13/2005 00:02'!
platformSymbol
	"NmBaseUtil platformSymbol"
	PlatformSymbol ifNil: [PlatformSymbol _ Smalltalk platformName asLowercase asSymbol ].
	^PlatformSymbol! !

!NmBaseUtil class methodsFor: 'system' stamp: 'mu 5/13/2005 00:02'!
resetSystem
	"NmBaseUtil resetSystem"
	! !

!NmBaseUtil class methodsFor: 'system' stamp: 'mu 6/15/2005 23:50'!
shortImageName
	"NmBaseUtil shortImageName"
	^ FileDirectory
		localNameFor: (Smalltalk fullNameForImageNamed: Smalltalk imageName)! !

!NmBaseUtil class methodsFor: 'system' stamp: 'mu 6/15/2005 23:52'!
shortImagePrefix
	^ FileDirectory baseNameFor: self shortImageName! !

!NmBaseUtil class methodsFor: 'system' stamp: 'mu 5/12/2005 23:03'!
startUp

	PlatformSymbol := nil.
! !


AlignmentMorph subclass: #NmBuilderMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

!NmBuilderMorph methodsFor: 'building' stamp: 'mu 6/30/2005 22:41'!
buildButtonOn: morph action: selector label: labelString help: helpString 
	| button |
	button _ (PluggableButtonMorph
				on: morph
				getState: #isOn
				action: selector)
				label: labelString.
	button hResizing: #spaceFill;
		 vResizing: #spaceFill;
		 setBalloonText: helpString.
	^ button! !

!NmBuilderMorph methodsFor: 'building' stamp: 'mu 6/30/2005 22:41'!
buildCheckBoxOn: morph action: actionSelector getSelector: getSelector help: helpString 
	^ UpdatingThreePhaseButtonMorph checkBox target: morph;
		 actionSelector: actionSelector;
		 getSelector: getSelector;
		 setBalloonText: helpString! !

!NmBuilderMorph methodsFor: 'building' stamp: 'mu 6/30/2005 22:41'!
buildRowLabeled: labelName 
	| rowMorph label |
	rowMorph _ AlignmentMorph newRow vResizing: #shrinkWrap.
	label _ TextMorph new contents: labelName;
				 lock.
	rowMorph addMorphBack: label.
	^ rowMorph! !

!NmBuilderMorph methodsFor: 'building' stamp: 'mu 6/30/2005 22:41'!
buildRow: leftMorph with: rightMorph
	^self buildRow: leftMorph with: rightMorph with: nil with: nil! !

!NmBuilderMorph methodsFor: 'building' stamp: 'mu 6/30/2005 22:41'!
buildRow: firstMorph with: secondMorph with: thirdMorph
	^self buildRow: firstMorph with: secondMorph with: thirdMorph with: nil! !

!NmBuilderMorph methodsFor: 'building' stamp: 'mu 6/30/2005 22:41'!
buildRow: firstMorph with: secondMorph with: thirdMorph with: fourthMorph 
	| rowMorph |
	rowMorph _ AlignmentMorph newRow.
	firstMorph notNil
		ifTrue: [rowMorph addMorphBack: firstMorph].
	secondMorph notNil
		ifTrue: [rowMorph addMorphBack: secondMorph].
	thirdMorph notNil
		ifTrue: [rowMorph addMorphBack: thirdMorph].
	fourthMorph notNil
		ifTrue: [rowMorph addMorphBack: fourthMorph].
	^ rowMorph! !

!NmBuilderMorph methodsFor: 'building' stamp: 'mu 6/30/2005 22:41'!
buildTextField: selector on: target
	| getter setter textField |
	getter _ selector.
	setter _ (getter , ':') asSymbol.
	textField _ PluggableTextMorph
				on: target
				text: getter
				accept: setter.
	textField acceptOnCR: true.
	textField hideScrollBarIndefinitely.
	textField borderWidth: 1.
	textField extent: 600@20.
	textField hResizing: #spaceFill;
		 vResizing: #spaceFill.
	^ textField! !


!NmBuilderMorph methodsFor: 'initialization' stamp: 'mu 6/30/2005 22:41'!
createSystemWindow
	|  window |
	self listDirection: #topToBottom.
	self hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	window _ (SystemWindow labelled: self class labelString)
				model: Model new.
	window
		addMorph: self
		frame: (0 @ 0 corner: 1 @ 1).
	window extent: self class windowExtent.
	^ window! !

!NmBuilderMorph methodsFor: 'initialization' stamp: 'mu 6/30/2005 22:41'!
createWindow
	"NmAbstractSettingMorph createSystemWindow openInWorld."
	^self createSystemWindow! !


!NmBuilderMorph methodsFor: 'testing' stamp: 'mu 6/30/2005 22:41'!
isOn
	^false! !


!NmBuilderMorph methodsFor: 'constants' stamp: 'mu 7/2/2005 00:17'!
backgroundFillStyle
	| fill |
	fill _ GradientFillStyle ramp: {0.0
					-> (Color
							r: 0.355
							g: 0.548
							b: 1.0). 1.0
					-> (Color
							r: 0.774
							g: 0.935
							b: 1.0)}.
	fill origin: self bounds topLeft + (61 @ 7).
	fill direction: 33 @ 37.
	fill radial: false.
	^ fill! !

!NmBuilderMorph methodsFor: 'constants' stamp: 'mu 7/2/2005 00:07'!
buttonFillStyle
	| fill |
	fill _ GradientFillStyle ramp: {0.0
					-> (Color
							r: 0.742
							g: 0.903
							b: 1.0). 1.0
					-> (Color
							r: 0.516
							g: 0.71
							b: 1.0)}.
	fill origin: self bounds topLeft + (14 @ 3).
	fill direction: 8 @ 6.
	fill radial: false.
	^ fill! !

!NmBuilderMorph methodsFor: 'constants' stamp: 'mu 7/2/2005 00:06'!
defaultButtonClass
	^ SimpleButtonMorph! !


!NmBuilderMorph methodsFor: 'private' stamp: 'mu 7/2/2005 00:07'!
buttonName: aString action: aSymbol 
	^ self defaultButtonClass new target: self;
		 label: aString;
		 actionSelector: aSymbol;
		
		color: (Color gray: 0.8);
		 fillStyle: self buttonFillStyle;
		 borderWidth: 4;
		 borderColor: #complexAltRaised;
		 cornerStyle: #square! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmBuilderMorph class
	instanceVariableNames: ''!

!NmBuilderMorph class methodsFor: 'instance creation' stamp: 'mu 6/30/2005 22:45'!
open
	"self open"
	^ self new openInWorld! !


NmBuilderMorph subclass: #NmAbstractSettingsMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

!NmAbstractSettingsMorph methodsFor: 'private' stamp: 'mu 4/7/2005 23:08'!
buildResetDefaultButtonRow
	| default row |
	default _ (PluggableButtonMorph on: self getState: #isOn action: #resetDefaults) label: 'Reset to default values'.

	default
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: 'set NmSettings to default values'.

	row _ AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		addAllMorphs: (Array with: default );
		extent: 120@35.
	
	^row! !

!NmAbstractSettingsMorph methodsFor: 'private' stamp: 'mu 4/3/2005 23:50'!
buildTextField: selector 
	^ self buildTextField: selector on: self settingClass! !

!NmAbstractSettingsMorph methodsFor: 'private' stamp: 'mu 4/7/2005 23:15'!
createResetDefaultButtonRow
	| row |
	row _ self buildResetDefaultButtonRow.
	self addMorphBack: row.
	^ row! !

!NmAbstractSettingsMorph methodsFor: 'private' stamp: 'mu 4/29/2005 23:53'!
viewMapOn: aNmWorldMap
	NmWorldMapMorph openSingleOn: aNmWorldMap! !


!NmAbstractSettingsMorph methodsFor: 'initialization' stamp: 'mu 4/4/2005 00:15'!
createSystemWindow
	|  window |
	self listDirection: #topToBottom.
	self hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	window _ (SystemWindow labelled: self class labelString)
				model: Model new.
	window
		addMorph: self
		frame: (0 @ 0 corner: 1 @ 1).
	window extent: self class windowExtent.
	^ window! !

!NmAbstractSettingsMorph methodsFor: 'initialization' stamp: 'mu 4/4/2005 00:04'!
createWindow
	"NmAbstractSettingMorph createSystemWindow openInWorld."
	^self createSystemWindow! !


!NmAbstractSettingsMorph methodsFor: 'actions' stamp: 'mu 2/19/2003 15:55'!
resetDefaults
	self settingClass resetDefaults.
	"self delete"! !

!NmAbstractSettingsMorph methodsFor: 'actions' stamp: 'ns 1/22/2003 17:23'!
save
	self settingClass store! !


!NmAbstractSettingsMorph methodsFor: 'factory' stamp: 'mu 4/4/2005 00:12'!
settingClass
	^ self class settingClass! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmAbstractSettingsMorph class
	instanceVariableNames: ''!

!NmAbstractSettingsMorph class methodsFor: 'instance creation' stamp: 'mu 4/4/2005 00:03'!
createWindow
	^self new createWindow! !

!NmAbstractSettingsMorph class methodsFor: 'instance creation' stamp: 'ns 1/22/2003 16:52'!
open
	"NmSettingMorph open"
	^ self createWindow openInWorldExtent: self windowExtent! !


!NmAbstractSettingsMorph class methodsFor: 'factory' stamp: 'ns 1/22/2003 16:41'!
settingClass
	self subclassResponsibility! !


!NmAbstractSettingsMorph class methodsFor: 'constants' stamp: 'mu 5/29/2003 12:54'!
windowExtent
	self subclassResponsibility! !


Error subclass: #NmError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!


Model subclass: #NmFileouter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmFileouter class
	instanceVariableNames: ''!

!NmFileouter class methodsFor: 'actions' stamp: 'mu 7/5/2005 20:02'!
fileoutServerModule
"NmFileouter fileoutServerModule"

"Class categories"
| cs |
#(
'NetMorph-Support-Common'
'NetMorph-Support-Server'
'NetMorph-Server-MapServer'
'NetMorph-WorldMap'
'NetMorph-Morphic-WorldMap'
) do: [:each |
SystemOrganization fileOutCategory: each.
].

"System changes"
cs _ ChangeSet basicNewNamed: 'NetMorph-Server-SysChanges'.
cs atSelector: #getText class: PluggableTextMorph put: #add. "override"
cs atSelector: #asNmUrl class: String put: #add. 
cs atSelector: #isNmUrlString class: String put: #add. 
cs atSelector: #isIpAndPortString class: String put: #add. 
cs atSelector: #absoluteFromText: class: Url class put: #add. 
cs atSelector: #isNmUrl class: Object put: #add. 
cs atSelector: #isNmUrl class: Url put: #add. 
cs fileOut.! !


Object subclass: #NmFlapSetup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!
!NmFlapSetup commentStamp: '<historical>' prior: 0!
To add aMorph to NetMorph Flap;

1)	make a morph.
2)	add the definition to NmFlapSetup class>>quadsDefiningNetMorphFlap.
3)	do "NmFlapSetup reInstall.".

Browser newOnClass: NmFlapSetup class selector: #quadsDefiningNetMorphFlap!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmFlapSetup class
	instanceVariableNames: ''!

!NmFlapSetup class methodsFor: 'class initialization' stamp: 'mu 6/19/2005 08:40'!
addFlap
	"NmFlapSetup addFlap."
	| aFlapTab |
	self netMorphFlapTab notNil ifTrue: [^ nil].
	aFlapTab _ self newNetMorphFlapTab.
	aFlapTab setBalloonText: self balloonTextForFlaps.
	Flaps addGlobalFlap: aFlapTab.
	ActiveWorld addGlobalFlaps.
	aFlapTab
		changeTabText: (Vocabulary eToyVocabulary translatedWordingFor: self tabName asSymbol).
	^ aFlapTab! !

!NmFlapSetup class methodsFor: 'class initialization' stamp: 'ns 2/14/2003 13:38'!
destroyFlap
	"NmFlapSetup destroyFlap."
	"PartsBin initialize."
	(ActiveWorld flapTabs
		select: [:each | each flapID = self tabName])
		do: [:each | each destroyFlap]! !

!NmFlapSetup class methodsFor: 'class initialization' stamp: 'kuri-t 2/20/2003 12:26'!
reInstall
	"NmFlapSetup reInstall."
	NmFlapSetup destroyFlap.
	PartsBin initialize.
	NmFlapSetup addFlap! !


!NmFlapSetup class methodsFor: 'constans' stamp: 'ns 9/13/2002 15:11'!
balloonTextForFlaps
	^ 'NetMorph tools!!' copy! !

!NmFlapSetup class methodsFor: 'constans' stamp: 'ns 9/13/2002 15:12'!
flapColor
	^ Color
		r: 0.516
		g: 0.452
		b: 1.0! !

!NmFlapSetup class methodsFor: 'constans' stamp: 'mu 6/18/2005 23:04'!
stripColor
	^self flapColor alpha: 0.3! !

!NmFlapSetup class methodsFor: 'constans' stamp: 'ns 2/14/2003 13:22'!
tabSymbol
	^ #NetMorph! !


!NmFlapSetup class methodsFor: 'accessing' stamp: 'mu 6/19/2005 00:48'!
netMorphFlapTab
	^ ActiveWorld submorphs
		detect: [:each | (each isKindOf: FlapTab)
				and: [each flapID = self tabName]]
		ifNone: []! !


!NmFlapSetup class methodsFor: 'private' stamp: 'mu 6/21/2005 06:57'!
addPanelsTo: aPartsBin
	NmServerManager isMapServerOnlyImage ifTrue: [^self].
	aPartsBin addMorphFront: NmProjectControlPanelMorph new.! !

!NmFlapSetup class methodsFor: 'private' stamp: 'mu 6/19/2005 08:41'!
newNetMorphFlapTab
	| aFlapTab aStrip |
	aStrip _ PartsBin newPartsBinWithOrientation: #leftToRight from: self quadsDefiningNetMorphFlap.
	aFlapTab _ FlapTab new referent: aStrip beSticky.
	aFlapTab
		setName: self tabName
		edge: #bottom
		color: self flapColor.
	aStrip extent: self currentWorld width @ 78.
	aFlapTab position: 104 @ (self currentWorld height - aFlapTab height).
	aStrip beFlap: true.
	aStrip color: self stripColor.
	aStrip autoLineLayout: true.
	self addPanelsTo: aStrip.
	^ aFlapTab! !

!NmFlapSetup class methodsFor: 'private' stamp: 'mu 6/19/2005 08:42'!
quadsDefiningNetMorphFlapForClient
	"Answer a fully-instantiated flap named 'NetMorph' to be placed at the bottom of the screen, for use when it is the only flap shown upon web launch"
		"class					makeThumbnail		nameInFlap		ballonText"
	^ #(
		(NmWorldMapMorph		createWindow			'WorldMap'		'organize the World Map')
		(NmSettingsMorph		createWindow			'Setting'			'NetMorph settings')
	)! !

!NmFlapSetup class methodsFor: 'private' stamp: 'mu 2/19/2003 14:38'!
quadsDefiningNetMorphFlapForClientServer
	^self quadsDefiningNetMorphFlapForClient, self quadsDefiningNetMorphFlapForServer
! !

!NmFlapSetup class methodsFor: 'private' stamp: 'kuri-t 2/20/2003 12:17'!
quadsDefiningNetMorphFlapForServer
	"Answer a fully-instantiated flap named 'NetMorph' to be placed at the bottom of the screen, for use when it is the only flap shown upon web launch"
		"class					makeThumbnail		nameInFlap		ballonText"
	^ #(
		(NmServerSettingsMorph		createWindow			'Server Setting'			'NetMorph Server settings')
	)! !

!NmFlapSetup class methodsFor: 'private' stamp: 'ns 2/14/2003 13:23'!
tabName
	^ self tabSymbol! !


!NmFlapSetup class methodsFor: 'predefined flaps' stamp: 'mu 5/29/2005 03:19'!
quadsDefiningNetMorphFlap
	^ NmServerManager isWarpServerInstalled
		ifTrue: [NmServerManager isMapServerInstalled
				ifTrue: [self quadsDefiningNetMorphFlapForClientServer]
				ifFalse: [self quadsDefiningNetMorphFlapForClient]]
		ifFalse: [self quadsDefiningNetMorphFlapForServer]! !


Object subclass: #NmImageId
	instanceVariableNames: ''
	classVariableNames: 'LastIdString LastImageName LastIp'
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmImageId class
	instanceVariableNames: 'current'!

!NmImageId class methodsFor: 'accessing' stamp: 'mu 5/14/2005 00:42'!
current
	^ current! !


!NmImageId class methodsFor: 'private' stamp: 'mu 5/13/2005 00:51'!
hasEnvironmentChanged
	"NmImageId hasEnvironmentChanged"
	self lastIp ~= NmBaseUtil localAddress ifTrue: [^true].
	self lastImageName ~= SmalltalkImage current imageName ifTrue: [^true].
	^false
	! !

!NmImageId class methodsFor: 'private' stamp: 'mu 6/18/2005 00:32'!
lastIdString
	LastIdString
		ifNil: [LastIdString _ UUID new asString].
	^ LastIdString! !

!NmImageId class methodsFor: 'private' stamp: 'mu 5/13/2005 00:40'!
lastImageName
	LastImageName
		ifNil: [LastImageName _ SmalltalkImage current imageName].
	^ LastImageName! !

!NmImageId class methodsFor: 'private' stamp: 'mu 5/13/2005 00:25'!
lastIp
	LastIp
		ifNil: [LastIp _ NmBaseUtil localAddress].
	^ LastIp! !

!NmImageId class methodsFor: 'private' stamp: 'mu 5/14/2005 00:37'!
rememberEnvironment
	current
		ifNotNilDo: [:uid | LastIdString _ uid asString].
	LastIp _ NmBaseUtil localAddress.
	LastImageName _ SmalltalkImage current imageName! !


!NmImageId class methodsFor: 'class initialization' stamp: 'mu 1/15/2005 01:45'!
initCurrent
	self initCurrent: UUID new.
	! !

!NmImageId class methodsFor: 'class initialization' stamp: 'mu 5/14/2005 00:43'!
initCurrent: uuid 
	| oldCurrent |
	oldCurrent _ current.
	current _ uuid.
	oldCurrent = current
		ifFalse: [self changed: #imageIdNew with: current asString]! !

!NmImageId class methodsFor: 'class initialization' stamp: 'mu 5/14/2005 00:42'!
initialize
	"NmImageId initialize"
	LastIdString _ LastIp _ LastImageName _ nil.
	self nuke.
	self rememberEnvironment.
	self initCurrent.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.
	! !

!NmImageId class methodsFor: 'class initialization' stamp: 'mu 5/4/2005 17:56'!
obsolete
	"NmImageId initialize"
	self nuke.
	Smalltalk removeFromStartUpList: self.
	Smalltalk removeFromShutDownList: self.
	! !


!NmImageId class methodsFor: 'actions' stamp: 'mu 5/13/2005 23:54'!
nuke
	"self nuke"
	self changed: #imageIdNuked with: current asString.
	current _ nil.
	! !

!NmImageId class methodsFor: 'actions' stamp: 'mu 1/15/2005 01:46'!
resetTo: uuid 
	| newCurrent |
	newCurrent _ (uuid isMemberOf: UUID)
				ifTrue: [uuid]
				ifFalse: [[UUID fromString: uuid asString]
						on: Error
						do: [:ex | ex return: nil]].
	newCurrent isNil
		ifTrue: [^ self].
	self nuke.
	self initCurrent: newCurrent.
	! !


!NmImageId class methodsFor: 'system startup' stamp: 'mu 5/13/2005 00:50'!
shutDown
	self nuke! !

!NmImageId class methodsFor: 'system startup' stamp: 'mu 5/13/2005 00:50'!
startUp
	self hasEnvironmentChanged
		ifTrue: [self initCurrent]
		ifFalse: [self
				initCurrent: (UUID fromString: self lastIdString)].
	self rememberEnvironment! !


Notification subclass: #NmNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!


Object subclass: #NmProperties
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!
!NmProperties commentStamp: '<historical>' prior: 0!
I represent an appication specific name/value properties.

My subclasses will have many default value provider methods. 
Or just use #at: #at:put like a normal dictionary.

#creator
[:masashi | ^umezawa] 
#version 0.4 M.U. 11/21/1999 22:12!


!NmProperties methodsFor: 'converting' stamp: 'ns 1/20/2003 18:46'!
asArray
	| idx outArr |
	idx _ 0.
	outArr _ Array new: self size.
	self dictionary
		associationsDo: [:assoc | outArr
				at: (idx _ idx + 1)
				put: (Array with: assoc key with: assoc value)].
	^ outArr! !

!NmProperties methodsFor: 'converting' stamp: 'ns 1/20/2003 18:46'!
fromArray: aKeyValueArray 
	"brace expressions are no longer used for Squeak 2.7+: M.U. 11/21/1999 22:15"
	"instead use: #(#(key1 value1) #(key2 value2))"
	| dict |
	dict _ self defaultDictionaryClass new: aKeyValueArray size.
	aKeyValueArray
		do: [:each | dict at: each first put: each last].
	self dictionary: dict! !


!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:45'!
at: aKey 
	^ self dictionary
		at: aKey
		ifAbsent: []! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
at: aKey ifAbsentPutValue: aValue 
	^ self dictionary
		at: aKey
		ifAbsent: [self dictionary at: aKey put: aValue]! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:45'!
at: aKey ifAbsentPut: aBlock 
	^ self dictionary at: aKey ifAbsentPut: aBlock! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:45'!
at: aKey ifAbsent: aBlock 
	^ self dictionary at: aKey ifAbsent: aBlock! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
at: aKey put: aValue 
	| val |
	val _ aValue.
	"for self class >> newFrom: aKeyValueArray"
	aValue == #true
		ifTrue: [val _ true].
	aValue == #false
		ifTrue: [val _ false].
	aValue == #nil
		ifTrue: [val _ nil].
	^ self dictionary at: aKey put: val! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
disable: aKey 
	^ self at: aKey put: false! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
enable: aKey 
	^ self at: aKey put: true! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
includesKey: aKey 
	^ self dictionary includesKey: aKey! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
inherit: aNmProperties 
	aNmProperties
		keysAndValuesDo: [:key :value | self at: key ifAbsentPutValue: value]! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
keys
	^ self dictionary keys! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
overridden: aNmProperties 
	aNmProperties
		keysAndValuesDo: [:key :value | self at: key put: value]! !

!NmProperties methodsFor: 'actions' stamp: 'mu 2/12/2003 16:53'!
removeKey: aKey
	^ self dictionary
		removeKey: aKey! !

!NmProperties methodsFor: 'actions' stamp: 'mu 2/12/2003 16:53'!
removeKey: aKey ifAbsent: aBlock
	^ self dictionary
		removeKey: aKey ifAbsent: aBlock! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
size
	^ self dictionary size! !


!NmProperties methodsFor: 'factory' stamp: 'ns 1/20/2003 18:46'!
defaultDictionaryClass
	^ IdentityDictionary! !


!NmProperties methodsFor: 'accessing' stamp: 'ns 1/20/2003 18:46'!
dictionary
	dictionary isNil
		ifTrue: [dictionary _ self defaultDictionaryClass new].
	^ dictionary! !

!NmProperties methodsFor: 'accessing' stamp: 'ns 1/20/2003 18:46'!
dictionary: aValue 
	dictionary _ aValue! !


!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
do: aBlock 
	^ self dictionary do: aBlock! !

!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
keysAndValuesDo: aBlock 
	^ self dictionary keysAndValuesDo: aBlock! !

!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
keysDo: aBlock 
	^ self dictionary keysDo: aBlock! !

!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
valuesDo: aBlock 
	^ self dictionary valuesDo: aBlock! !


!NmProperties methodsFor: 'initialize-release' stamp: 'ns 1/20/2003 18:45'!
initialize
	"do nothing"! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmProperties class
	instanceVariableNames: ''!

!NmProperties class methodsFor: 'examples' stamp: 'ns 1/20/2003 18:45'!
example1
	"NmProperties example1"
	| props |
	props _ NmProperties newFrom: #(#(#SqIsCool #true) #(#defaultPassword #fooBar) #(#greeting 'Hi!!') ).
	^ props! !

!NmProperties class methodsFor: 'examples' stamp: 'ns 1/20/2003 18:45'!
example2
	"NmProperties example2"
	| props |
	props _ self example1.
	props disable: #SqIsCool.
	^ props
		overridden: (NmProperties newFrom: #(#(#SqueakVersion 2.7) #(#greeting 'Hello!!') ))! !


!NmProperties class methodsFor: 'instance creation' stamp: 'ns 1/20/2003 18:45'!
new
	^ super new initialize! !

!NmProperties class methodsFor: 'instance creation' stamp: 'ns 1/20/2003 18:45'!
newFrom: aKeyValueArray 
	"brace expressions are no longer used for Squeak 2.7+: M.U. 11/21/1999 22:15"
	"instead use: #(#(key1 value1) #(key2 value2))"
	^ self new fromArray: aKeyValueArray! !


Object subclass: #NmServerManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmServerManager class
	instanceVariableNames: ''!

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 5/29/2005 03:18'!
isMapServerInstalled
	"NmServerManager isMapServerInstalled"
	^ (Smalltalk includesKey: #SoapServerSetup)
			and: [Smalltalk includesKey: #NmWorldMapServer]! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 6/3/2005 09:26'!
isMapServerOnlyImage
	"NmServerManager isMapServerOnlyImage"
	^ (Smalltalk includesKey: #NmSettings) not
			! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 5/30/2005 18:12'!
isMapServerRunning
	"NmServerManager isMapServerRunning"
	| descriptor |
	descriptor _ ('http:', NmServerSettings mapServerPort asString) asSymbol.
	^SoapServerSetup runningTransportDescriptions includes: descriptor! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 11/22/2003 03:30'!
isWarpServerInstalled
	"NmServerManager isWarpServerInstalled"
	^ Smalltalk includesKey: #NmRemoteService ! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 5/31/2005 18:04'!
startMapServer
	"NmServerManager startMapServer"
	| setup |
	self isMapServerInstalled
		ifTrue: [(setup _ self soapServerSetup)
				ifNotNil: [setup restartAt: #http port: NmServerSettings mapServerPort]]
		ifFalse: [self error: 'MapServer is not installed']! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 6/1/2005 16:36'!
startMapServerWithBroadcaster
	"NmServerManager startMapServer"
	self startMapServer.
	NmWorldMapLocationBroadcaster default start! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 11/23/2003 01:51'!
startWarpServer
	"NmServerManager startWarpServer"
	| server |
	self isWarpServerInstalled
		ifTrue: [server := self warpServer.
			server
				ifNil: [server := NmRemoteService startOn: NmSettings warpPort]
				ifNotNil: [server portNumber = NmSettings warpPort
						ifFalse: [server portNumber: NmSettings warpPort]]]
		ifFalse: [self error: 'WarpServer is not installed']! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 5/29/2005 03:20'!
stopMapServer
	"NmServerManager stopMapServer"
	| setup |
	(setup _ self soapServerSetup)
		ifNotNil: [setup
				stop: (Array with: #http)]! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 6/1/2005 16:37'!
stopMapServerWithBroadcaster
	"NmServerManager startMapServer"
	self stopMapServer.
	NmWorldMapLocationBroadcaster default stop! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 11/25/2003 03:05'!
stopWarpServer
	"NmServerManager stopWarpServer"
	"clean old sockets if any"
	| setup openSockets |
	(setup := self warpServer)
		ifNotNil: [setup stop].
	openSockets := Socket allInstances
				select: [:each | each isWaitingForConnection].
	(openSockets
		select: [:each | each port = NmSettings warpPort])
		do: [:each | each closeAndDestroy].
	NmRemoteService allInstances do: [:e| e kill]! !


!NmServerManager class methodsFor: 'factory' stamp: 'mu 5/6/2003 01:38'!
soapServerSetup
	^ Smalltalk
		at: #SoapServerSetup
		ifAbsent: []! !

!NmServerManager class methodsFor: 'factory' stamp: 'mu 11/22/2003 20:12'!
warpServer
	^ NmRemoteService current
		! !


Object subclass: #NmTimerUpdater
	instanceVariableNames: 'updateProcess intervalSeconds priority'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

!NmTimerUpdater methodsFor: 'accessing' stamp: 'mu 5/20/2005 19:33'!
intervalSeconds
	intervalSeconds
		ifNil: [intervalSeconds _ self class defaultIntervalSeconds].
	^ intervalSeconds! !

!NmTimerUpdater methodsFor: 'accessing' stamp: 'mu 5/20/2005 19:33'!
intervalSeconds: seconds 
	intervalSeconds _ seconds.
	self start! !

!NmTimerUpdater methodsFor: 'accessing' stamp: 'mu 5/20/2005 19:33'!
interval: msec 
	"obsolete"
	self intervalSeconds: (msec / 1000) asFloat! !

!NmTimerUpdater methodsFor: 'accessing' stamp: 'mu 5/31/2005 00:53'!
priority
	priority
		ifNil: [priority _ self class defaultPriority].
	^ priority! !

!NmTimerUpdater methodsFor: 'accessing' stamp: 'mu 5/31/2005 00:54'!
priority: anInteger
	priority _ anInteger asInteger! !


!NmTimerUpdater methodsFor: 'actions' stamp: 'mu 5/20/2005 19:33'!
isRunning
	^updateProcess notNil	! !

!NmTimerUpdater methodsFor: 'actions' stamp: 'mu 5/31/2005 00:54'!
start
	[self update] forkAt: self priority.
	updateProcess notNil
		ifTrue: [updateProcess terminate].
	updateProcess _ [[| currentValue nextValue | 
			currentValue _ Time millisecondClockValue.
			nextValue _ self nextMillisecondClockValue.
			(Delay forMilliseconds: nextValue - currentValue) wait.
			true]
				whileTrue: [self update]] newProcess.
	updateProcess priority: self priority.
	updateProcess resume! !

!NmTimerUpdater methodsFor: 'actions' stamp: 'mu 5/20/2005 19:33'!
startAfter: seconds 
	[(Delay forSeconds: seconds) wait.
	self start]
		forkAt: Processor userBackgroundPriority! !

!NmTimerUpdater methodsFor: 'actions' stamp: 'mu 5/20/2005 19:33'!
stop
	updateProcess notNil
		ifTrue: [updateProcess terminate].
	updateProcess _ nil! !

!NmTimerUpdater methodsFor: 'actions' stamp: 'mu 5/20/2005 19:35'!
update
	
	! !


!NmTimerUpdater methodsFor: 'private' stamp: 'mu 5/20/2005 19:33'!
nextMillisecondClockValue
	^ Time millisecondClockValue + (self intervalSeconds * 1000) truncated! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmTimerUpdater class
	instanceVariableNames: 'default'!

!NmTimerUpdater class methodsFor: 'instance creation' stamp: 'mu 5/20/2005 19:35'!
default
	default isNil
		ifTrue: [default _ self basicNew].
	^ default! !

!NmTimerUpdater class methodsFor: 'instance creation' stamp: 'mu 5/20/2005 19:33'!
new
	self shouldNotImplement! !


!NmTimerUpdater class methodsFor: 'constants' stamp: 'mu 5/20/2005 19:35'!
defaultIntervalSeconds
	^ 10! !

!NmTimerUpdater class methodsFor: 'constants' stamp: 'mu 5/31/2005 00:48'!
defaultPriority
	^ Processor userSchedulingPriority - 1! !


!NmTimerUpdater class methodsFor: 'class initialization' stamp: 'mu 5/20/2005 19:34'!
flushInstances
	"self flushInstances."
	self allInstances
		do: [:each | 
			each stop.
			each become: Object new].
	Smalltalk garbageCollect.
	default notNil
		ifTrue: [default class = self ifTrue: [default stop].
			default _ nil]! !


Object subclass: #NmTranscript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmTranscript class
	instanceVariableNames: 'isDebugging'!

!NmTranscript class methodsFor: 'actions' stamp: 'mu 4/11/2003 14:47'!
crShow: aString
	isDebugging ifTrue: [Transcript cr; show: aString]! !

!NmTranscript class methodsFor: 'actions' stamp: 'mu 4/28/2005 17:23'!
enable: aBoolean
	"NmTranscript enable: true"
	isDebugging _ aBoolean == true! !

!NmTranscript class methodsFor: 'actions' stamp: 'mu 4/11/2003 14:44'!
isDebugging
	^isDebugging! !

!NmTranscript class methodsFor: 'actions' stamp: 'mu 4/11/2003 14:47'!
show: aString
	isDebugging ifTrue: [Transcript show: aString]! !

!NmTranscript class methodsFor: 'actions' stamp: 'mu 4/11/2003 14:44'!
toggleDebugging
	isDebugging _ isDebugging not! !


!NmTranscript class methodsFor: 'class initialization' stamp: 'mu 4/11/2003 14:44'!
initialize
	"NmTranscript initialize"
	isDebugging _ false! !


HttpUrl subclass: #NmUrl
	instanceVariableNames: 'isLocal ipAddress triedResolveIp triedResolveHost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

!NmUrl methodsFor: 'converting' stamp: 'mu 5/10/2005 20:29'!
asDestination
	^self asString! !

!NmUrl methodsFor: 'converting' stamp: 'mu 12/29/2004 22:48'!
asNmUrl
	^self! !


!NmUrl methodsFor: 'printing' stamp: 'MU 11/11/2002 15:55'!
csvString
	"'nm://localhost:37458' asUrl csvString"
	| stream |
	stream _ WriteStream on: String new.
	stream nextPutAll: self printString.
	^ stream contents! !

!NmUrl methodsFor: 'printing' stamp: 'mu 4/12/2003 19:37'!
displayString
	^ (self host isNil
			or: [self port isNil])
		ifTrue: [String new]
		ifFalse: [super toText]! !

!NmUrl methodsFor: 'printing' stamp: 'mu 3/10/2003 17:42'!
shortPrintString
	"'nm://localhost:37459' asUrl shortPrintString"
	"'nm://localhost:37458' asUrl shortPrintString"
	| stream |
	stream _ WriteStream on: String new.
	stream nextPutAll: self host.
	self port = NmSettings defaultWarpPort
		ifFalse: [stream nextPut: $:.
			stream nextPutAll: self port printString].
	^ stream contents! !


!NmUrl methodsFor: 'comparing' stamp: 'MU 10/3/2002 10:33'!
hash
	^ (self port hash hashMultiply + self path hash hashMultiply + self hostId hash hashMultiply) 




! !

!NmUrl methodsFor: 'comparing' stamp: 'MU 11/11/2002 16:07'!
hostId

	^ self hostOrIpAddress asString, ':', self port asString! !

!NmUrl methodsFor: 'comparing' stamp: 'mu 1/11/2005 00:55'!
hostOrIpEquals: otherNmUrl 
	self class = otherNmUrl class
		ifFalse: [^ false].
	self host = otherNmUrl host
		ifTrue: [^ true].
	self ipAddress = otherNmUrl ipAddress
		ifTrue: [true].
	^ false! !

!NmUrl methodsFor: 'comparing' stamp: 'mu 4/12/2003 19:38'!
truelyEquals: otherNmUrl 
	self class = otherNmUrl class
		ifFalse: [^ false].
	self host = otherNmUrl host
		ifFalse: [^ false].
	self port = otherNmUrl port
		ifFalse: [^ false].
	self path = otherNmUrl path
		ifFalse: [^ false].
	self ipAddress = otherNmUrl ipAddress
		ifFalse: [^ false].
	^ true! !

!NmUrl methodsFor: 'comparing' stamp: 'mu 3/23/2003 13:15'!
= otherNmUrl 
	"'nm://localhost' asUrl = 'nm://127.0.0.1' asUrl"
	self class = otherNmUrl class ifFalse: [^ false].
	self port = otherNmUrl port ifFalse: [^ false].
	self path = otherNmUrl path ifFalse: [^ false].
	^ self hostId = otherNmUrl hostId! !


!NmUrl methodsFor: 'accessing' stamp: 'MU 10/1/2002 15:35'!
host
	self authority isNil ifTrue: [authority _  ''].
	^self authority	! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 6/22/2005 22:30'!
host: aString 
	
	authority _ aString asString.! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 3/23/2003 13:01'!
ipAddress
	^ ipAddress! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 1/11/2005 00:23'!
ipAddress: aString
	ipAddress _ aString.
	! !

!NmUrl methodsFor: 'accessing' stamp: 'MU 10/1/2002 16:36'!
isLocal
	isLocal isNil
		ifTrue: [isLocal _ false].
	^ isLocal! !

!NmUrl methodsFor: 'accessing' stamp: 'MU 10/1/2002 16:36'!
isLocal: aBoolean
	isLocal _ aBoolean! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 3/23/2003 15:56'!
port
	port ifNil: [port _ NmSettings defaultWarpPort].
	^ port.! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 1/12/2005 02:25'!
port: anInteger
	port _ self class trimmedPortNumber: anInteger! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 1/10/2005 01:20'!
triedResolveHost
	triedResolveHost ifNil: [triedResolveHost _ false].
	^triedResolveHost! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 1/10/2005 01:20'!
triedResolveIp
	triedResolveIp ifNil: [triedResolveIp _ false].
	^triedResolveIp! !


!NmUrl methodsFor: 'actions' stamp: 'mu 3/23/2003 13:15'!
hostOrIpAddress
	^ self host isNil
		ifTrue: [self ipAddress]
		ifFalse: [self host]! !

!NmUrl methodsFor: 'actions' stamp: 'mu 3/23/2003 13:14'!
ipAddressOrHost
	^ self ipAddress isNil
		ifTrue: [self host]
		ifFalse: [self ipAddress]! !

!NmUrl methodsFor: 'actions' stamp: 'mu 6/22/2005 22:32'!
parsedIp
	self host = 'localhost'
		ifTrue: [self ipAddress: '127.0.0.1'.
			^ self ipAddress].
	(NetNameResolver addressFromString: self host) notNil
		ifTrue: [self ipAddress: self host asString].
	^ self ipAddress! !

!NmUrl methodsFor: 'actions' stamp: 'mu 1/11/2005 00:19'!
resolvedHost
	| host |
	self triedResolveHost
		ifTrue: [^ self host].
	host := NetNameResolver nameForAddress: self ipAddress timeout: 3.
	triedResolveHost := true.
	host isNil
		ifFalse: [self host: host].
	^ self host! !

!NmUrl methodsFor: 'actions' stamp: 'mu 7/5/2005 20:23'!
resolvedIp
	| ip |
	(self triedResolveIp or: [self ipAddress notNil])
		ifTrue: [^ self ipAddress].
	ip _ (NmWorldMap default atName: self host)
				ifNotNilDo: [:ent | ent ip]. 
	ip isNil
		ifTrue: [| address | 
			address _ [NetNameResolver addressForName: self host timeout: 3]
						on: NameLookupFailure
						do: [:ex | ex return: nil].
			address
				ifNotNilDo: [:addr | ip _ NetNameResolver stringFromAddress: addr]].
	triedResolveIp _ true.
	ip isNil
		ifFalse: [self ipAddress: ip].
	^ self ipAddress! !


!NmUrl methodsFor: 'initialize-release' stamp: 'mu 1/10/2005 01:19'!
initialize
	path _ #().
	self initResolved! !

!NmUrl methodsFor: 'initialize-release' stamp: 'mu 1/10/2005 01:19'!
initResolved
	triedResolveIp _ triedResolveHost _ false! !

!NmUrl methodsFor: 'initialize-release' stamp: 'mu 1/10/2005 01:31'!
privateInitializeFromText: aString 
	super privateInitializeFromText: aString.
	"set host if possible"
	authority := authority asLowercase.
	authority = '127.0.0.1'
		ifTrue: [authority := 'localhost']
		ifFalse: [| addressStr | 
			addressStr := NetNameResolver addressFromString: authority.
			addressStr notNil
				ifTrue: [| hostname | 
					ipAddress := authority.
					hostname := NetNameResolver nameForAddress: addressStr timeout: 1.
					authority := hostname isNil
								ifTrue: [authority]
								ifFalse: [hostname asLowercase]]]! !


!NmUrl methodsFor: 'testing' stamp: 'mu 4/15/2003 16:38'!
isNmUrl
	^true! !


!NmUrl methodsFor: 'printing-sixx'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self toText.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmUrl class
	instanceVariableNames: 'local'!

!NmUrl class methodsFor: 'instance creation-sixx' stamp: 'mu 12/29/2004 22:51'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self absoluteFromText: (SixxXmlUtil characterDataFrom: sixxElement)! !


!NmUrl class methodsFor: 'instance creation' stamp: 'mu 1/11/2005 00:35'!
createLocal
	"NmUrl createLocal"
	| url |
	url _ (self protocolIdentifier , NmUtil localHostname , ':' , NmSettings warpPort printString) asUrl.
	^ url! !

!NmUrl class methodsFor: 'instance creation' stamp: 'mu 12/29/2004 22:40'!
fromCsvString: aString 
	"NmUrl fromCsvString: 'nm://localhost:37458/'"
	^self readFrom: (ReadStream on: aString).
	! !

!NmUrl class methodsFor: 'instance creation' stamp: 'mu 1/12/2005 02:24'!
host: hostname port: portNumber 
	| inst portPart urlStr |
	inst _ self basicNew.
	portPart _ self trimmedPortNumber:  portNumber.
	urlStr _ self protocolIdentifier , hostname , ':' , portPart asString.
	inst privateInitializeFromText: urlStr.
	^ inst! !

!NmUrl class methodsFor: 'instance creation' stamp: 'MU 10/2/2002 20:26'!
new
	^super new initialize! !

!NmUrl class methodsFor: 'instance creation' stamp: 'mu 1/12/2005 02:12'!
readFrom: aStream
	"NmUrl readFrom: 'nm://localhost:37458/' readStream"
	"NmUrl readFrom: 'localhost:37458/' readStream"
	"NmUrl readFrom: 'auau' readStream"
	| str tokens port hostIndex host  |
	str _ aStream contents.
	(str beginsWith: self protocolIdentifier) ifTrue: [^str asUrl].
	tokens _ str findTokens: '/:'.
	port _ tokens detect: [:each | each isAllDigits] ifNone: [NmSettings defaultWarpPort asString].
	hostIndex _ tokens indexOf: port.
	host _ hostIndex = 0 ifTrue: [tokens last] ifFalse: [tokens at: ((hostIndex -1) max: 1)].
	^self host: host port: port
	! !


!NmUrl class methodsFor: 'class initialization' stamp: 'MU 10/3/2002 12:44'!
initialize
	"NmUrl initialize"
	local _ nil! !


!NmUrl class methodsFor: 'accessing' stamp: 'MU 10/3/2002 10:19'!
local
	local isNil ifTrue: [local _ self createLocal].
	^local! !


!NmUrl class methodsFor: 'constants' stamp: 'mu 12/29/2004 22:51'!
protcolIdentifier
	^ 'nm://'.! !

!NmUrl class methodsFor: 'constants' stamp: 'mu 1/11/2005 00:35'!
protocolIdentifier
	^ 'nm://'.! !

!NmUrl class methodsFor: 'constants' stamp: 'mu 12/29/2004 22:51'!
scheme
	^ 'nm'.! !


!NmUrl class methodsFor: 'private' stamp: 'mu 1/12/2005 02:29'!
trimmedPortNumber: portNumber 
	"NmUrl trimmedPortNumber: 99999"
	"NmUrl trimmedPortNumber: -100"
	"NmUrl trimmedPortNumber: 200"
	^ (portNumber asNumber between: 0 and: 65535)
		ifTrue: [portNumber]
		ifFalse: [NmSettings defaultWarpPort]! !


Object subclass: #NmWorldInfoReadWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmWorldInfoReadWriter class
	instanceVariableNames: ''!

!NmWorldInfoReadWriter class methodsFor: 'private' stamp: 'mu 5/1/2005 22:07'!
createPath
	 ^self defaultPath = '.' ifTrue: [FileDirectory default pathName] ifFalse: [self defaultPath].
	! !

!NmWorldInfoReadWriter class methodsFor: 'private' stamp: 'mu 5/10/2005 17:55'!
trimFileName: fileNameString 
	^(fileNameString endsWith: '.csv')
				ifTrue: [fileNameString]
				ifFalse: [fileNameString , '.csv'].
	! !


!NmWorldInfoReadWriter class methodsFor: 'accessing' stamp: 'mu 6/15/2005 23:07'!
defaultPath
	NmServerManager isMapServerInstalled ifTrue: [^NmServerSettings mapPath].
	^NmSettings mapPath! !

!NmWorldInfoReadWriter class methodsFor: 'accessing' stamp: 'mu 6/15/2005 23:07'!
defaultPath: path
	NmServerManager isMapServerInstalled ifTrue: [^NmServerSettings mapPath: path].
	^NmSettings mapPath: path! !


!NmWorldInfoReadWriter class methodsFor: 'actions' stamp: 'mu 5/10/2005 17:55'!
deleteCsvFile: fileNameString 
	| readDir |
	readDir _ FileDirectory on: self createPath.
	(readDir directoryExists: readDir pathName)
		ifTrue: [readDir
				deleteFileNamed: (self trimFileName: fileNameString)
				ifAbsent: [^ false].
			^ true].
	^ false! !

!NmWorldInfoReadWriter class methodsFor: 'actions' stamp: 'mu 5/10/2005 17:55'!
getCsvStringFromFile: fileNameString
	| readDir fileName |
	fileName _ self trimFileName: fileNameString.
	readDir _ FileDirectory on: self createPath.
	(readDir fileExists: fileName)
		ifTrue: [| fileStream csvString | 
	
			[fileStream _ CrLfFileStream readOnlyFileNamed: (readDir fullNameFor: fileName).
			csvString _ fileStream contentsOfEntireFile]
				ensure: [fileStream
						ifNotNil: [fileStream close]].
			^ csvString]
		ifFalse: [^ nil]! !

!NmWorldInfoReadWriter class methodsFor: 'actions' stamp: 'mu 5/2/2005 01:38'!
listAllCsvFileNamesFromDirectory
	| readDir | 
	readDir _ FileDirectory on: self createPath.
	(readDir directoryExists: readDir pathName)
		ifTrue: [| fileNames mapNames | 
			fileNames _ readDir fileNames. 
			mapNames _ fileNames
						select: [:each | '*.csv' match: each].
			^ mapNames]
		ifFalse: [^ #()]! !

!NmWorldInfoReadWriter class methodsFor: 'actions' stamp: 'mu 5/12/2005 23:55'!
listMapCsvFileNamesFromDirectory
	"just for backward compatibility"
	| prefix |
	prefix _ NmBaseSettings resolverPrefix.
	^self listAllCsvFileNamesFromDirectory reject: [:each | each beginsWith: prefix]! !

!NmWorldInfoReadWriter class methodsFor: 'actions' stamp: 'mu 5/13/2005 23:10'!
putCsvString: csvString toFile: fileNameString 
	| writeFileStream path dir fileName |
	fileName _ self trimFileName: fileNameString.
	path _ self createPath.
	dir _ FileDirectory on: path.
	[[writeFileStream _ CrLfFileStream
				forceNewFileNamed: (dir fullNameFor: fileName)]
		on: CannotDeleteFileException , FileDoesNotExistException
		do: [:ex | 
			self defaultPath: FileDirectory default pathName.
			NmTranscript show: 'Wrong path or filename: ' , dir pathName asString , '. Use default directory anyway'.
			^ self putCsvString: csvString toFile: fileNameString].
	writeFileStream
		ifNil: [NmTranscript show: 'Falied to store to: ', fileNameString. ^nil].
	writeFileStream nextPutAll: csvString]
		ensure: [writeFileStream
				ifNotNil: [writeFileStream close]]! !

NmAbstractInitializer initialize!
NmBaseSettings initialize!
NmBaseUtil initialize!
NmImageId initialize!
NmTranscript initialize!
NmUrl initialize!